/* bigstringinRecord.h generated from bigstringinRecord.dbd */

#ifndef INC_bigstringinRecord_H
#define INC_bigstringinRecord_H

#include "epicsTypes.h"
#include "link.h"
#include "epicsMutex.h"
#include "ellLib.h"
#include "epicsTime.h"

typedef struct bigstringinRecord {
    char                name[61];   /* Record Name */
    char                desc[41];   /* Descriptor */
    char                asg[29];    /* Access Security Group */
    epicsEnum16         scan;       /* Scan Mechanism */
    epicsEnum16         pini;       /* Process at iocInit */
    epicsInt16          phas;       /* Scan Phase */
    char                evnt[40];   /* Event Name */
    epicsInt16          tse;        /* Time Stamp Event */
    DBLINK              tsel;       /* Time Stamp Link */
    epicsEnum16         dtyp;       /* Device Type */
    epicsInt16          disv;       /* Disable Value */
    epicsInt16          disa;       /* Disable */
    DBLINK              sdis;       /* Scanning Disable */
    epicsMutexId        mlok;       /* Monitor lock */
    ELLLIST             mlis;       /* Monitor List */
    epicsUInt8          disp;       /* Disable putField */
    epicsUInt8          proc;       /* Force Processing */
    epicsEnum16         stat;       /* Alarm Status */
    epicsEnum16         sevr;       /* Alarm Severity */
    epicsEnum16         nsta;       /* New Alarm Status */
    epicsEnum16         nsev;       /* New Alarm Severity */
    epicsEnum16         acks;       /* Alarm Ack Severity */
    epicsEnum16         ackt;       /* Alarm Ack Transient */
    epicsEnum16         diss;       /* Disable Alarm Sevrty */
    epicsUInt8          lcnt;       /* Lock Count */
    epicsUInt8          pact;       /* Record active */
    epicsUInt8          putf;       /* dbPutField process */
    epicsUInt8          rpro;       /* Reprocess  */
    struct asgMember    *asp;       /* Access Security Pvt */
    struct processNotify *ppn;      /* pprocessNotify */
    struct processNotifyRecord *ppnr; /* pprocessNotifyRecord */
    struct scan_element *spvt;      /* Scan Private */
    struct rset         *rset;      /* Address of RSET */
    struct dset         *dset;      /* DSET address */
    void                *dpvt;      /* Device Private */
    struct dbRecordType *rdes;      /* Address of dbRecordType */
    struct lockRecord   *lset;      /* Lock Set */
    epicsEnum16         prio;       /* Scheduling Priority */
    epicsUInt8          tpro;       /* Trace Processing */
    char                bkpt;       /* Break Point */
    epicsUInt8          udf;        /* Undefined */
    epicsEnum16         udfs;       /* Undefined Alarm Sevrty */
    epicsTimeStamp      time;       /* Time */
    DBLINK              flnk;       /* Forward Process Link */
    char                val[200];   /* Current Value */
    char                oval[200];  /* Previous Value */
} bigstringinRecord;

typedef enum {
	bigstringinRecordNAME = 0,
	bigstringinRecordDESC = 1,
	bigstringinRecordASG = 2,
	bigstringinRecordSCAN = 3,
	bigstringinRecordPINI = 4,
	bigstringinRecordPHAS = 5,
	bigstringinRecordEVNT = 6,
	bigstringinRecordTSE = 7,
	bigstringinRecordTSEL = 8,
	bigstringinRecordDTYP = 9,
	bigstringinRecordDISV = 10,
	bigstringinRecordDISA = 11,
	bigstringinRecordSDIS = 12,
	bigstringinRecordMLOK = 13,
	bigstringinRecordMLIS = 14,
	bigstringinRecordDISP = 15,
	bigstringinRecordPROC = 16,
	bigstringinRecordSTAT = 17,
	bigstringinRecordSEVR = 18,
	bigstringinRecordNSTA = 19,
	bigstringinRecordNSEV = 20,
	bigstringinRecordACKS = 21,
	bigstringinRecordACKT = 22,
	bigstringinRecordDISS = 23,
	bigstringinRecordLCNT = 24,
	bigstringinRecordPACT = 25,
	bigstringinRecordPUTF = 26,
	bigstringinRecordRPRO = 27,
	bigstringinRecordASP = 28,
	bigstringinRecordPPN = 29,
	bigstringinRecordPPNR = 30,
	bigstringinRecordSPVT = 31,
	bigstringinRecordRSET = 32,
	bigstringinRecordDSET = 33,
	bigstringinRecordDPVT = 34,
	bigstringinRecordRDES = 35,
	bigstringinRecordLSET = 36,
	bigstringinRecordPRIO = 37,
	bigstringinRecordTPRO = 38,
	bigstringinRecordBKPT = 39,
	bigstringinRecordUDF = 40,
	bigstringinRecordUDFS = 41,
	bigstringinRecordTIME = 42,
	bigstringinRecordFLNK = 43,
	bigstringinRecordVAL = 44,
	bigstringinRecordOVAL = 45
} bigstringinFieldIndex;

#ifdef GEN_SIZE_OFFSET

#include <epicsAssert.h>
#include <epicsExport.h>
#ifdef __cplusplus
extern "C" {
#endif
static int bigstringinRecordSizeOffset(dbRecordType *prt)
{
    bigstringinRecord *prec = 0;

    assert(prt->no_fields == 46);
    prt->papFldDes[bigstringinRecordNAME]->size = sizeof(prec->name);
    prt->papFldDes[bigstringinRecordDESC]->size = sizeof(prec->desc);
    prt->papFldDes[bigstringinRecordASG]->size = sizeof(prec->asg);
    prt->papFldDes[bigstringinRecordSCAN]->size = sizeof(prec->scan);
    prt->papFldDes[bigstringinRecordPINI]->size = sizeof(prec->pini);
    prt->papFldDes[bigstringinRecordPHAS]->size = sizeof(prec->phas);
    prt->papFldDes[bigstringinRecordEVNT]->size = sizeof(prec->evnt);
    prt->papFldDes[bigstringinRecordTSE]->size = sizeof(prec->tse);
    prt->papFldDes[bigstringinRecordTSEL]->size = sizeof(prec->tsel);
    prt->papFldDes[bigstringinRecordDTYP]->size = sizeof(prec->dtyp);
    prt->papFldDes[bigstringinRecordDISV]->size = sizeof(prec->disv);
    prt->papFldDes[bigstringinRecordDISA]->size = sizeof(prec->disa);
    prt->papFldDes[bigstringinRecordSDIS]->size = sizeof(prec->sdis);
    prt->papFldDes[bigstringinRecordMLOK]->size = sizeof(prec->mlok);
    prt->papFldDes[bigstringinRecordMLIS]->size = sizeof(prec->mlis);
    prt->papFldDes[bigstringinRecordDISP]->size = sizeof(prec->disp);
    prt->papFldDes[bigstringinRecordPROC]->size = sizeof(prec->proc);
    prt->papFldDes[bigstringinRecordSTAT]->size = sizeof(prec->stat);
    prt->papFldDes[bigstringinRecordSEVR]->size = sizeof(prec->sevr);
    prt->papFldDes[bigstringinRecordNSTA]->size = sizeof(prec->nsta);
    prt->papFldDes[bigstringinRecordNSEV]->size = sizeof(prec->nsev);
    prt->papFldDes[bigstringinRecordACKS]->size = sizeof(prec->acks);
    prt->papFldDes[bigstringinRecordACKT]->size = sizeof(prec->ackt);
    prt->papFldDes[bigstringinRecordDISS]->size = sizeof(prec->diss);
    prt->papFldDes[bigstringinRecordLCNT]->size = sizeof(prec->lcnt);
    prt->papFldDes[bigstringinRecordPACT]->size = sizeof(prec->pact);
    prt->papFldDes[bigstringinRecordPUTF]->size = sizeof(prec->putf);
    prt->papFldDes[bigstringinRecordRPRO]->size = sizeof(prec->rpro);
    prt->papFldDes[bigstringinRecordASP]->size = sizeof(prec->asp);
    prt->papFldDes[bigstringinRecordPPN]->size = sizeof(prec->ppn);
    prt->papFldDes[bigstringinRecordPPNR]->size = sizeof(prec->ppnr);
    prt->papFldDes[bigstringinRecordSPVT]->size = sizeof(prec->spvt);
    prt->papFldDes[bigstringinRecordRSET]->size = sizeof(prec->rset);
    prt->papFldDes[bigstringinRecordDSET]->size = sizeof(prec->dset);
    prt->papFldDes[bigstringinRecordDPVT]->size = sizeof(prec->dpvt);
    prt->papFldDes[bigstringinRecordRDES]->size = sizeof(prec->rdes);
    prt->papFldDes[bigstringinRecordLSET]->size = sizeof(prec->lset);
    prt->papFldDes[bigstringinRecordPRIO]->size = sizeof(prec->prio);
    prt->papFldDes[bigstringinRecordTPRO]->size = sizeof(prec->tpro);
    prt->papFldDes[bigstringinRecordBKPT]->size = sizeof(prec->bkpt);
    prt->papFldDes[bigstringinRecordUDF]->size = sizeof(prec->udf);
    prt->papFldDes[bigstringinRecordUDFS]->size = sizeof(prec->udfs);
    prt->papFldDes[bigstringinRecordTIME]->size = sizeof(prec->time);
    prt->papFldDes[bigstringinRecordFLNK]->size = sizeof(prec->flnk);
    prt->papFldDes[bigstringinRecordVAL]->size = sizeof(prec->val);
    prt->papFldDes[bigstringinRecordOVAL]->size = sizeof(prec->oval);
    prt->papFldDes[bigstringinRecordNAME]->offset = (unsigned short)((char *)&prec->name - (char *)prec);
    prt->papFldDes[bigstringinRecordDESC]->offset = (unsigned short)((char *)&prec->desc - (char *)prec);
    prt->papFldDes[bigstringinRecordASG]->offset = (unsigned short)((char *)&prec->asg - (char *)prec);
    prt->papFldDes[bigstringinRecordSCAN]->offset = (unsigned short)((char *)&prec->scan - (char *)prec);
    prt->papFldDes[bigstringinRecordPINI]->offset = (unsigned short)((char *)&prec->pini - (char *)prec);
    prt->papFldDes[bigstringinRecordPHAS]->offset = (unsigned short)((char *)&prec->phas - (char *)prec);
    prt->papFldDes[bigstringinRecordEVNT]->offset = (unsigned short)((char *)&prec->evnt - (char *)prec);
    prt->papFldDes[bigstringinRecordTSE]->offset = (unsigned short)((char *)&prec->tse - (char *)prec);
    prt->papFldDes[bigstringinRecordTSEL]->offset = (unsigned short)((char *)&prec->tsel - (char *)prec);
    prt->papFldDes[bigstringinRecordDTYP]->offset = (unsigned short)((char *)&prec->dtyp - (char *)prec);
    prt->papFldDes[bigstringinRecordDISV]->offset = (unsigned short)((char *)&prec->disv - (char *)prec);
    prt->papFldDes[bigstringinRecordDISA]->offset = (unsigned short)((char *)&prec->disa - (char *)prec);
    prt->papFldDes[bigstringinRecordSDIS]->offset = (unsigned short)((char *)&prec->sdis - (char *)prec);
    prt->papFldDes[bigstringinRecordMLOK]->offset = (unsigned short)((char *)&prec->mlok - (char *)prec);
    prt->papFldDes[bigstringinRecordMLIS]->offset = (unsigned short)((char *)&prec->mlis - (char *)prec);
    prt->papFldDes[bigstringinRecordDISP]->offset = (unsigned short)((char *)&prec->disp - (char *)prec);
    prt->papFldDes[bigstringinRecordPROC]->offset = (unsigned short)((char *)&prec->proc - (char *)prec);
    prt->papFldDes[bigstringinRecordSTAT]->offset = (unsigned short)((char *)&prec->stat - (char *)prec);
    prt->papFldDes[bigstringinRecordSEVR]->offset = (unsigned short)((char *)&prec->sevr - (char *)prec);
    prt->papFldDes[bigstringinRecordNSTA]->offset = (unsigned short)((char *)&prec->nsta - (char *)prec);
    prt->papFldDes[bigstringinRecordNSEV]->offset = (unsigned short)((char *)&prec->nsev - (char *)prec);
    prt->papFldDes[bigstringinRecordACKS]->offset = (unsigned short)((char *)&prec->acks - (char *)prec);
    prt->papFldDes[bigstringinRecordACKT]->offset = (unsigned short)((char *)&prec->ackt - (char *)prec);
    prt->papFldDes[bigstringinRecordDISS]->offset = (unsigned short)((char *)&prec->diss - (char *)prec);
    prt->papFldDes[bigstringinRecordLCNT]->offset = (unsigned short)((char *)&prec->lcnt - (char *)prec);
    prt->papFldDes[bigstringinRecordPACT]->offset = (unsigned short)((char *)&prec->pact - (char *)prec);
    prt->papFldDes[bigstringinRecordPUTF]->offset = (unsigned short)((char *)&prec->putf - (char *)prec);
    prt->papFldDes[bigstringinRecordRPRO]->offset = (unsigned short)((char *)&prec->rpro - (char *)prec);
    prt->papFldDes[bigstringinRecordASP]->offset = (unsigned short)((char *)&prec->asp - (char *)prec);
    prt->papFldDes[bigstringinRecordPPN]->offset = (unsigned short)((char *)&prec->ppn - (char *)prec);
    prt->papFldDes[bigstringinRecordPPNR]->offset = (unsigned short)((char *)&prec->ppnr - (char *)prec);
    prt->papFldDes[bigstringinRecordSPVT]->offset = (unsigned short)((char *)&prec->spvt - (char *)prec);
    prt->papFldDes[bigstringinRecordRSET]->offset = (unsigned short)((char *)&prec->rset - (char *)prec);
    prt->papFldDes[bigstringinRecordDSET]->offset = (unsigned short)((char *)&prec->dset - (char *)prec);
    prt->papFldDes[bigstringinRecordDPVT]->offset = (unsigned short)((char *)&prec->dpvt - (char *)prec);
    prt->papFldDes[bigstringinRecordRDES]->offset = (unsigned short)((char *)&prec->rdes - (char *)prec);
    prt->papFldDes[bigstringinRecordLSET]->offset = (unsigned short)((char *)&prec->lset - (char *)prec);
    prt->papFldDes[bigstringinRecordPRIO]->offset = (unsigned short)((char *)&prec->prio - (char *)prec);
    prt->papFldDes[bigstringinRecordTPRO]->offset = (unsigned short)((char *)&prec->tpro - (char *)prec);
    prt->papFldDes[bigstringinRecordBKPT]->offset = (unsigned short)((char *)&prec->bkpt - (char *)prec);
    prt->papFldDes[bigstringinRecordUDF]->offset = (unsigned short)((char *)&prec->udf - (char *)prec);
    prt->papFldDes[bigstringinRecordUDFS]->offset = (unsigned short)((char *)&prec->udfs - (char *)prec);
    prt->papFldDes[bigstringinRecordTIME]->offset = (unsigned short)((char *)&prec->time - (char *)prec);
    prt->papFldDes[bigstringinRecordFLNK]->offset = (unsigned short)((char *)&prec->flnk - (char *)prec);
    prt->papFldDes[bigstringinRecordVAL]->offset = (unsigned short)((char *)&prec->val - (char *)prec);
    prt->papFldDes[bigstringinRecordOVAL]->offset = (unsigned short)((char *)&prec->oval - (char *)prec);
    prt->rec_size = sizeof(*prec);
    return 0;
}
epicsExportRegistrar(bigstringinRecordSizeOffset);

#ifdef __cplusplus
}
#endif
#endif /* GEN_SIZE_OFFSET */

#endif /* INC_bigstringinRecord_H */
