/* byteRecord.h generated from byteRecord.dbd */

#ifndef INC_byteRecord_H
#define INC_byteRecord_H

#include "epicsTypes.h"
#include "link.h"
#include "epicsMutex.h"
#include "ellLib.h"
#include "epicsTime.h"

typedef struct byterRecord {
    char                name[61];   /* Record Name */
    char                desc[41];   /* Descriptor */
    char                asg[29];    /* Access Security Group */
    epicsEnum16         scan;       /* Scan Mechanism */
    epicsEnum16         pini;       /* Process at iocInit */
    epicsInt16          phas;       /* Scan Phase */
    char                evnt[40];   /* Event Name */
    epicsInt16          tse;        /* Time Stamp Event */
    DBLINK              tsel;       /* Time Stamp Link */
    epicsEnum16         dtyp;       /* Device Type */
    epicsInt16          disv;       /* Disable Value */
    epicsInt16          disa;       /* Disable */
    DBLINK              sdis;       /* Scanning Disable */
    epicsMutexId        mlok;       /* Monitor lock */
    ELLLIST             mlis;       /* Monitor List */
    epicsUInt8          disp;       /* Disable putField */
    epicsUInt8          proc;       /* Force Processing */
    epicsEnum16         stat;       /* Alarm Status */
    epicsEnum16         sevr;       /* Alarm Severity */
    epicsEnum16         nsta;       /* New Alarm Status */
    epicsEnum16         nsev;       /* New Alarm Severity */
    epicsEnum16         acks;       /* Alarm Ack Severity */
    epicsEnum16         ackt;       /* Alarm Ack Transient */
    epicsEnum16         diss;       /* Disable Alarm Sevrty */
    epicsUInt8          lcnt;       /* Lock Count */
    epicsUInt8          pact;       /* Record active */
    epicsUInt8          putf;       /* dbPutField process */
    epicsUInt8          rpro;       /* Reprocess  */
    struct asgMember    *asp;       /* Access Security Pvt */
    struct processNotify *ppn;      /* pprocessNotify */
    struct processNotifyRecord *ppnr; /* pprocessNotifyRecord */
    struct scan_element *spvt;      /* Scan Private */
    struct rset         *rset;      /* Address of RSET */
    struct dset         *dset;      /* DSET address */
    void                *dpvt;      /* Device Private */
    struct dbRecordType *rdes;      /* Address of dbRecordType */
    struct lockRecord   *lset;      /* Lock Set */
    epicsEnum16         prio;       /* Scheduling Priority */
    epicsUInt8          tpro;       /* Trace Processing */
    char                bkpt;       /* Break Point */
    epicsUInt8          udf;        /* Undefined */
    epicsEnum16         udfs;       /* Undefined Alarm Sevrty */
    epicsTimeStamp      time;       /* Time */
    DBLINK              flnk;       /* Forward Process Link */
    epicsInt8           val;        /* Current EGU Value */
    epicsInt8           prec;       /* Display Precision */
    char                egu[16];    /* Engineering Units */
    epicsInt8           hopr;       /* High Operating Range */
    epicsInt8           lopr;       /* Low Operating Range */
    epicsInt8           drvh;       /* High Operating Range */
    epicsInt8           drvl;       /* Low Operating Range */
    epicsInt8           hihi;       /* Hihi Alarm Limit */
    epicsInt8           lolo;       /* Lolo Alarm Limit */
    epicsInt8           high;       /* High Alarm Limit */
    epicsInt8           low;        /* Low Alarm Limit */
    epicsEnum16         hhsv;       /* Hihi Severity */
    epicsEnum16         llsv;       /* Lolo Severity */
    epicsEnum16         hsv;        /* High Severity */
    epicsEnum16         lsv;        /* Low Severity */
    epicsInt8           hyst;       /* Alarm Deadband */
    epicsInt8           adel;       /* Archive Deadband */
    epicsInt8           mdel;       /* Monitor Deadband */
    epicsInt8           lalm;       /* Last Value Alarmed */
    epicsInt8           alst;       /* Last Value Archived */
    epicsInt8           mlst;       /* Last Val Monitored */
} byterRecord;

typedef enum {
	byterRecordNAME = 0,
	byterRecordDESC = 1,
	byterRecordASG = 2,
	byterRecordSCAN = 3,
	byterRecordPINI = 4,
	byterRecordPHAS = 5,
	byterRecordEVNT = 6,
	byterRecordTSE = 7,
	byterRecordTSEL = 8,
	byterRecordDTYP = 9,
	byterRecordDISV = 10,
	byterRecordDISA = 11,
	byterRecordSDIS = 12,
	byterRecordMLOK = 13,
	byterRecordMLIS = 14,
	byterRecordDISP = 15,
	byterRecordPROC = 16,
	byterRecordSTAT = 17,
	byterRecordSEVR = 18,
	byterRecordNSTA = 19,
	byterRecordNSEV = 20,
	byterRecordACKS = 21,
	byterRecordACKT = 22,
	byterRecordDISS = 23,
	byterRecordLCNT = 24,
	byterRecordPACT = 25,
	byterRecordPUTF = 26,
	byterRecordRPRO = 27,
	byterRecordASP = 28,
	byterRecordPPN = 29,
	byterRecordPPNR = 30,
	byterRecordSPVT = 31,
	byterRecordRSET = 32,
	byterRecordDSET = 33,
	byterRecordDPVT = 34,
	byterRecordRDES = 35,
	byterRecordLSET = 36,
	byterRecordPRIO = 37,
	byterRecordTPRO = 38,
	byterRecordBKPT = 39,
	byterRecordUDF = 40,
	byterRecordUDFS = 41,
	byterRecordTIME = 42,
	byterRecordFLNK = 43,
	byterRecordVAL = 44,
	byterRecordPREC = 45,
	byterRecordEGU = 46,
	byterRecordHOPR = 47,
	byterRecordLOPR = 48,
	byterRecordDRVH = 49,
	byterRecordDRVL = 50,
	byterRecordHIHI = 51,
	byterRecordLOLO = 52,
	byterRecordHIGH = 53,
	byterRecordLOW = 54,
	byterRecordHHSV = 55,
	byterRecordLLSV = 56,
	byterRecordHSV = 57,
	byterRecordLSV = 58,
	byterRecordHYST = 59,
	byterRecordADEL = 60,
	byterRecordMDEL = 61,
	byterRecordLALM = 62,
	byterRecordALST = 63,
	byterRecordMLST = 64
} byterFieldIndex;

#ifdef GEN_SIZE_OFFSET

#include <epicsAssert.h>
#include <epicsExport.h>
#ifdef __cplusplus
extern "C" {
#endif
static int byterRecordSizeOffset(dbRecordType *prt)
{
    byterRecord *prec = 0;

    assert(prt->no_fields == 65);
    prt->papFldDes[byterRecordNAME]->size = sizeof(prec->name);
    prt->papFldDes[byterRecordDESC]->size = sizeof(prec->desc);
    prt->papFldDes[byterRecordASG]->size = sizeof(prec->asg);
    prt->papFldDes[byterRecordSCAN]->size = sizeof(prec->scan);
    prt->papFldDes[byterRecordPINI]->size = sizeof(prec->pini);
    prt->papFldDes[byterRecordPHAS]->size = sizeof(prec->phas);
    prt->papFldDes[byterRecordEVNT]->size = sizeof(prec->evnt);
    prt->papFldDes[byterRecordTSE]->size = sizeof(prec->tse);
    prt->papFldDes[byterRecordTSEL]->size = sizeof(prec->tsel);
    prt->papFldDes[byterRecordDTYP]->size = sizeof(prec->dtyp);
    prt->papFldDes[byterRecordDISV]->size = sizeof(prec->disv);
    prt->papFldDes[byterRecordDISA]->size = sizeof(prec->disa);
    prt->papFldDes[byterRecordSDIS]->size = sizeof(prec->sdis);
    prt->papFldDes[byterRecordMLOK]->size = sizeof(prec->mlok);
    prt->papFldDes[byterRecordMLIS]->size = sizeof(prec->mlis);
    prt->papFldDes[byterRecordDISP]->size = sizeof(prec->disp);
    prt->papFldDes[byterRecordPROC]->size = sizeof(prec->proc);
    prt->papFldDes[byterRecordSTAT]->size = sizeof(prec->stat);
    prt->papFldDes[byterRecordSEVR]->size = sizeof(prec->sevr);
    prt->papFldDes[byterRecordNSTA]->size = sizeof(prec->nsta);
    prt->papFldDes[byterRecordNSEV]->size = sizeof(prec->nsev);
    prt->papFldDes[byterRecordACKS]->size = sizeof(prec->acks);
    prt->papFldDes[byterRecordACKT]->size = sizeof(prec->ackt);
    prt->papFldDes[byterRecordDISS]->size = sizeof(prec->diss);
    prt->papFldDes[byterRecordLCNT]->size = sizeof(prec->lcnt);
    prt->papFldDes[byterRecordPACT]->size = sizeof(prec->pact);
    prt->papFldDes[byterRecordPUTF]->size = sizeof(prec->putf);
    prt->papFldDes[byterRecordRPRO]->size = sizeof(prec->rpro);
    prt->papFldDes[byterRecordASP]->size = sizeof(prec->asp);
    prt->papFldDes[byterRecordPPN]->size = sizeof(prec->ppn);
    prt->papFldDes[byterRecordPPNR]->size = sizeof(prec->ppnr);
    prt->papFldDes[byterRecordSPVT]->size = sizeof(prec->spvt);
    prt->papFldDes[byterRecordRSET]->size = sizeof(prec->rset);
    prt->papFldDes[byterRecordDSET]->size = sizeof(prec->dset);
    prt->papFldDes[byterRecordDPVT]->size = sizeof(prec->dpvt);
    prt->papFldDes[byterRecordRDES]->size = sizeof(prec->rdes);
    prt->papFldDes[byterRecordLSET]->size = sizeof(prec->lset);
    prt->papFldDes[byterRecordPRIO]->size = sizeof(prec->prio);
    prt->papFldDes[byterRecordTPRO]->size = sizeof(prec->tpro);
    prt->papFldDes[byterRecordBKPT]->size = sizeof(prec->bkpt);
    prt->papFldDes[byterRecordUDF]->size = sizeof(prec->udf);
    prt->papFldDes[byterRecordUDFS]->size = sizeof(prec->udfs);
    prt->papFldDes[byterRecordTIME]->size = sizeof(prec->time);
    prt->papFldDes[byterRecordFLNK]->size = sizeof(prec->flnk);
    prt->papFldDes[byterRecordVAL]->size = sizeof(prec->val);
    prt->papFldDes[byterRecordPREC]->size = sizeof(prec->prec);
    prt->papFldDes[byterRecordEGU]->size = sizeof(prec->egu);
    prt->papFldDes[byterRecordHOPR]->size = sizeof(prec->hopr);
    prt->papFldDes[byterRecordLOPR]->size = sizeof(prec->lopr);
    prt->papFldDes[byterRecordDRVH]->size = sizeof(prec->drvh);
    prt->papFldDes[byterRecordDRVL]->size = sizeof(prec->drvl);
    prt->papFldDes[byterRecordHIHI]->size = sizeof(prec->hihi);
    prt->papFldDes[byterRecordLOLO]->size = sizeof(prec->lolo);
    prt->papFldDes[byterRecordHIGH]->size = sizeof(prec->high);
    prt->papFldDes[byterRecordLOW]->size = sizeof(prec->low);
    prt->papFldDes[byterRecordHHSV]->size = sizeof(prec->hhsv);
    prt->papFldDes[byterRecordLLSV]->size = sizeof(prec->llsv);
    prt->papFldDes[byterRecordHSV]->size = sizeof(prec->hsv);
    prt->papFldDes[byterRecordLSV]->size = sizeof(prec->lsv);
    prt->papFldDes[byterRecordHYST]->size = sizeof(prec->hyst);
    prt->papFldDes[byterRecordADEL]->size = sizeof(prec->adel);
    prt->papFldDes[byterRecordMDEL]->size = sizeof(prec->mdel);
    prt->papFldDes[byterRecordLALM]->size = sizeof(prec->lalm);
    prt->papFldDes[byterRecordALST]->size = sizeof(prec->alst);
    prt->papFldDes[byterRecordMLST]->size = sizeof(prec->mlst);
    prt->papFldDes[byterRecordNAME]->offset = (unsigned short)((char *)&prec->name - (char *)prec);
    prt->papFldDes[byterRecordDESC]->offset = (unsigned short)((char *)&prec->desc - (char *)prec);
    prt->papFldDes[byterRecordASG]->offset = (unsigned short)((char *)&prec->asg - (char *)prec);
    prt->papFldDes[byterRecordSCAN]->offset = (unsigned short)((char *)&prec->scan - (char *)prec);
    prt->papFldDes[byterRecordPINI]->offset = (unsigned short)((char *)&prec->pini - (char *)prec);
    prt->papFldDes[byterRecordPHAS]->offset = (unsigned short)((char *)&prec->phas - (char *)prec);
    prt->papFldDes[byterRecordEVNT]->offset = (unsigned short)((char *)&prec->evnt - (char *)prec);
    prt->papFldDes[byterRecordTSE]->offset = (unsigned short)((char *)&prec->tse - (char *)prec);
    prt->papFldDes[byterRecordTSEL]->offset = (unsigned short)((char *)&prec->tsel - (char *)prec);
    prt->papFldDes[byterRecordDTYP]->offset = (unsigned short)((char *)&prec->dtyp - (char *)prec);
    prt->papFldDes[byterRecordDISV]->offset = (unsigned short)((char *)&prec->disv - (char *)prec);
    prt->papFldDes[byterRecordDISA]->offset = (unsigned short)((char *)&prec->disa - (char *)prec);
    prt->papFldDes[byterRecordSDIS]->offset = (unsigned short)((char *)&prec->sdis - (char *)prec);
    prt->papFldDes[byterRecordMLOK]->offset = (unsigned short)((char *)&prec->mlok - (char *)prec);
    prt->papFldDes[byterRecordMLIS]->offset = (unsigned short)((char *)&prec->mlis - (char *)prec);
    prt->papFldDes[byterRecordDISP]->offset = (unsigned short)((char *)&prec->disp - (char *)prec);
    prt->papFldDes[byterRecordPROC]->offset = (unsigned short)((char *)&prec->proc - (char *)prec);
    prt->papFldDes[byterRecordSTAT]->offset = (unsigned short)((char *)&prec->stat - (char *)prec);
    prt->papFldDes[byterRecordSEVR]->offset = (unsigned short)((char *)&prec->sevr - (char *)prec);
    prt->papFldDes[byterRecordNSTA]->offset = (unsigned short)((char *)&prec->nsta - (char *)prec);
    prt->papFldDes[byterRecordNSEV]->offset = (unsigned short)((char *)&prec->nsev - (char *)prec);
    prt->papFldDes[byterRecordACKS]->offset = (unsigned short)((char *)&prec->acks - (char *)prec);
    prt->papFldDes[byterRecordACKT]->offset = (unsigned short)((char *)&prec->ackt - (char *)prec);
    prt->papFldDes[byterRecordDISS]->offset = (unsigned short)((char *)&prec->diss - (char *)prec);
    prt->papFldDes[byterRecordLCNT]->offset = (unsigned short)((char *)&prec->lcnt - (char *)prec);
    prt->papFldDes[byterRecordPACT]->offset = (unsigned short)((char *)&prec->pact - (char *)prec);
    prt->papFldDes[byterRecordPUTF]->offset = (unsigned short)((char *)&prec->putf - (char *)prec);
    prt->papFldDes[byterRecordRPRO]->offset = (unsigned short)((char *)&prec->rpro - (char *)prec);
    prt->papFldDes[byterRecordASP]->offset = (unsigned short)((char *)&prec->asp - (char *)prec);
    prt->papFldDes[byterRecordPPN]->offset = (unsigned short)((char *)&prec->ppn - (char *)prec);
    prt->papFldDes[byterRecordPPNR]->offset = (unsigned short)((char *)&prec->ppnr - (char *)prec);
    prt->papFldDes[byterRecordSPVT]->offset = (unsigned short)((char *)&prec->spvt - (char *)prec);
    prt->papFldDes[byterRecordRSET]->offset = (unsigned short)((char *)&prec->rset - (char *)prec);
    prt->papFldDes[byterRecordDSET]->offset = (unsigned short)((char *)&prec->dset - (char *)prec);
    prt->papFldDes[byterRecordDPVT]->offset = (unsigned short)((char *)&prec->dpvt - (char *)prec);
    prt->papFldDes[byterRecordRDES]->offset = (unsigned short)((char *)&prec->rdes - (char *)prec);
    prt->papFldDes[byterRecordLSET]->offset = (unsigned short)((char *)&prec->lset - (char *)prec);
    prt->papFldDes[byterRecordPRIO]->offset = (unsigned short)((char *)&prec->prio - (char *)prec);
    prt->papFldDes[byterRecordTPRO]->offset = (unsigned short)((char *)&prec->tpro - (char *)prec);
    prt->papFldDes[byterRecordBKPT]->offset = (unsigned short)((char *)&prec->bkpt - (char *)prec);
    prt->papFldDes[byterRecordUDF]->offset = (unsigned short)((char *)&prec->udf - (char *)prec);
    prt->papFldDes[byterRecordUDFS]->offset = (unsigned short)((char *)&prec->udfs - (char *)prec);
    prt->papFldDes[byterRecordTIME]->offset = (unsigned short)((char *)&prec->time - (char *)prec);
    prt->papFldDes[byterRecordFLNK]->offset = (unsigned short)((char *)&prec->flnk - (char *)prec);
    prt->papFldDes[byterRecordVAL]->offset = (unsigned short)((char *)&prec->val - (char *)prec);
    prt->papFldDes[byterRecordPREC]->offset = (unsigned short)((char *)&prec->prec - (char *)prec);
    prt->papFldDes[byterRecordEGU]->offset = (unsigned short)((char *)&prec->egu - (char *)prec);
    prt->papFldDes[byterRecordHOPR]->offset = (unsigned short)((char *)&prec->hopr - (char *)prec);
    prt->papFldDes[byterRecordLOPR]->offset = (unsigned short)((char *)&prec->lopr - (char *)prec);
    prt->papFldDes[byterRecordDRVH]->offset = (unsigned short)((char *)&prec->drvh - (char *)prec);
    prt->papFldDes[byterRecordDRVL]->offset = (unsigned short)((char *)&prec->drvl - (char *)prec);
    prt->papFldDes[byterRecordHIHI]->offset = (unsigned short)((char *)&prec->hihi - (char *)prec);
    prt->papFldDes[byterRecordLOLO]->offset = (unsigned short)((char *)&prec->lolo - (char *)prec);
    prt->papFldDes[byterRecordHIGH]->offset = (unsigned short)((char *)&prec->high - (char *)prec);
    prt->papFldDes[byterRecordLOW]->offset = (unsigned short)((char *)&prec->low - (char *)prec);
    prt->papFldDes[byterRecordHHSV]->offset = (unsigned short)((char *)&prec->hhsv - (char *)prec);
    prt->papFldDes[byterRecordLLSV]->offset = (unsigned short)((char *)&prec->llsv - (char *)prec);
    prt->papFldDes[byterRecordHSV]->offset = (unsigned short)((char *)&prec->hsv - (char *)prec);
    prt->papFldDes[byterRecordLSV]->offset = (unsigned short)((char *)&prec->lsv - (char *)prec);
    prt->papFldDes[byterRecordHYST]->offset = (unsigned short)((char *)&prec->hyst - (char *)prec);
    prt->papFldDes[byterRecordADEL]->offset = (unsigned short)((char *)&prec->adel - (char *)prec);
    prt->papFldDes[byterRecordMDEL]->offset = (unsigned short)((char *)&prec->mdel - (char *)prec);
    prt->papFldDes[byterRecordLALM]->offset = (unsigned short)((char *)&prec->lalm - (char *)prec);
    prt->papFldDes[byterRecordALST]->offset = (unsigned short)((char *)&prec->alst - (char *)prec);
    prt->papFldDes[byterRecordMLST]->offset = (unsigned short)((char *)&prec->mlst - (char *)prec);
    prt->rec_size = sizeof(*prec);
    return 0;
}
epicsExportRegistrar(byterRecordSizeOffset);

#ifdef __cplusplus
}
#endif
#endif /* GEN_SIZE_OFFSET */

#endif /* INC_byteRecord_H */
