/* ubyteRecord.h generated from ubyteRecord.dbd */

#ifndef INC_ubyteRecord_H
#define INC_ubyteRecord_H

#include "epicsTypes.h"
#include "link.h"
#include "epicsMutex.h"
#include "ellLib.h"
#include "epicsTime.h"

typedef struct ubyteRecord {
    char                name[61];   /* Record Name */
    char                desc[41];   /* Descriptor */
    char                asg[29];    /* Access Security Group */
    epicsEnum16         scan;       /* Scan Mechanism */
    epicsEnum16         pini;       /* Process at iocInit */
    epicsInt16          phas;       /* Scan Phase */
    char                evnt[40];   /* Event Name */
    epicsInt16          tse;        /* Time Stamp Event */
    DBLINK              tsel;       /* Time Stamp Link */
    epicsEnum16         dtyp;       /* Device Type */
    epicsInt16          disv;       /* Disable Value */
    epicsInt16          disa;       /* Disable */
    DBLINK              sdis;       /* Scanning Disable */
    epicsMutexId        mlok;       /* Monitor lock */
    ELLLIST             mlis;       /* Monitor List */
    epicsUInt8          disp;       /* Disable putField */
    epicsUInt8          proc;       /* Force Processing */
    epicsEnum16         stat;       /* Alarm Status */
    epicsEnum16         sevr;       /* Alarm Severity */
    epicsEnum16         nsta;       /* New Alarm Status */
    epicsEnum16         nsev;       /* New Alarm Severity */
    epicsEnum16         acks;       /* Alarm Ack Severity */
    epicsEnum16         ackt;       /* Alarm Ack Transient */
    epicsEnum16         diss;       /* Disable Alarm Sevrty */
    epicsUInt8          lcnt;       /* Lock Count */
    epicsUInt8          pact;       /* Record active */
    epicsUInt8          putf;       /* dbPutField process */
    epicsUInt8          rpro;       /* Reprocess  */
    struct asgMember    *asp;       /* Access Security Pvt */
    struct processNotify *ppn;      /* pprocessNotify */
    struct processNotifyRecord *ppnr; /* pprocessNotifyRecord */
    struct scan_element *spvt;      /* Scan Private */
    struct rset         *rset;      /* Address of RSET */
    struct dset         *dset;      /* DSET address */
    void                *dpvt;      /* Device Private */
    struct dbRecordType *rdes;      /* Address of dbRecordType */
    struct lockRecord   *lset;      /* Lock Set */
    epicsEnum16         prio;       /* Scheduling Priority */
    epicsUInt8          tpro;       /* Trace Processing */
    char                bkpt;       /* Break Point */
    epicsUInt8          udf;        /* Undefined */
    epicsEnum16         udfs;       /* Undefined Alarm Sevrty */
    epicsTimeStamp      time;       /* Time */
    DBLINK              flnk;       /* Forward Process Link */
    epicsUInt8          val;        /* Current EGU Value */
    epicsUInt8          prec;       /* Display Precision */
    char                egu[16];    /* Engineering Units */
    epicsUInt8          hopr;       /* High Operating Range */
    epicsUInt8          lopr;       /* Low Operating Range */
    epicsUInt8          drvh;       /* High Operating Range */
    epicsUInt8          drvl;       /* Low Operating Range */
    epicsUInt8          hihi;       /* Hihi Alarm Limit */
    epicsUInt8          lolo;       /* Lolo Alarm Limit */
    epicsUInt8          high;       /* High Alarm Limit */
    epicsUInt8          low;        /* Low Alarm Limit */
    epicsEnum16         hhsv;       /* Hihi Severity */
    epicsEnum16         llsv;       /* Lolo Severity */
    epicsEnum16         hsv;        /* High Severity */
    epicsEnum16         lsv;        /* Low Severity */
    epicsUInt8          hyst;       /* Alarm Deadband */
    epicsUInt8          adel;       /* Archive Deadband */
    epicsUInt8          mdel;       /* Monitor Deadband */
    epicsUInt8          lalm;       /* Last Value Alarmed */
    epicsUInt8          alst;       /* Last Value Archived */
    epicsUInt8          mlst;       /* Last Val Monitored */
} ubyteRecord;

typedef enum {
	ubyteRecordNAME = 0,
	ubyteRecordDESC = 1,
	ubyteRecordASG = 2,
	ubyteRecordSCAN = 3,
	ubyteRecordPINI = 4,
	ubyteRecordPHAS = 5,
	ubyteRecordEVNT = 6,
	ubyteRecordTSE = 7,
	ubyteRecordTSEL = 8,
	ubyteRecordDTYP = 9,
	ubyteRecordDISV = 10,
	ubyteRecordDISA = 11,
	ubyteRecordSDIS = 12,
	ubyteRecordMLOK = 13,
	ubyteRecordMLIS = 14,
	ubyteRecordDISP = 15,
	ubyteRecordPROC = 16,
	ubyteRecordSTAT = 17,
	ubyteRecordSEVR = 18,
	ubyteRecordNSTA = 19,
	ubyteRecordNSEV = 20,
	ubyteRecordACKS = 21,
	ubyteRecordACKT = 22,
	ubyteRecordDISS = 23,
	ubyteRecordLCNT = 24,
	ubyteRecordPACT = 25,
	ubyteRecordPUTF = 26,
	ubyteRecordRPRO = 27,
	ubyteRecordASP = 28,
	ubyteRecordPPN = 29,
	ubyteRecordPPNR = 30,
	ubyteRecordSPVT = 31,
	ubyteRecordRSET = 32,
	ubyteRecordDSET = 33,
	ubyteRecordDPVT = 34,
	ubyteRecordRDES = 35,
	ubyteRecordLSET = 36,
	ubyteRecordPRIO = 37,
	ubyteRecordTPRO = 38,
	ubyteRecordBKPT = 39,
	ubyteRecordUDF = 40,
	ubyteRecordUDFS = 41,
	ubyteRecordTIME = 42,
	ubyteRecordFLNK = 43,
	ubyteRecordVAL = 44,
	ubyteRecordPREC = 45,
	ubyteRecordEGU = 46,
	ubyteRecordHOPR = 47,
	ubyteRecordLOPR = 48,
	ubyteRecordDRVH = 49,
	ubyteRecordDRVL = 50,
	ubyteRecordHIHI = 51,
	ubyteRecordLOLO = 52,
	ubyteRecordHIGH = 53,
	ubyteRecordLOW = 54,
	ubyteRecordHHSV = 55,
	ubyteRecordLLSV = 56,
	ubyteRecordHSV = 57,
	ubyteRecordLSV = 58,
	ubyteRecordHYST = 59,
	ubyteRecordADEL = 60,
	ubyteRecordMDEL = 61,
	ubyteRecordLALM = 62,
	ubyteRecordALST = 63,
	ubyteRecordMLST = 64
} ubyteFieldIndex;

#ifdef GEN_SIZE_OFFSET

#include <epicsAssert.h>
#include <epicsExport.h>
#ifdef __cplusplus
extern "C" {
#endif
static int ubyteRecordSizeOffset(dbRecordType *prt)
{
    ubyteRecord *prec = 0;

    assert(prt->no_fields == 65);
    prt->papFldDes[ubyteRecordNAME]->size = sizeof(prec->name);
    prt->papFldDes[ubyteRecordDESC]->size = sizeof(prec->desc);
    prt->papFldDes[ubyteRecordASG]->size = sizeof(prec->asg);
    prt->papFldDes[ubyteRecordSCAN]->size = sizeof(prec->scan);
    prt->papFldDes[ubyteRecordPINI]->size = sizeof(prec->pini);
    prt->papFldDes[ubyteRecordPHAS]->size = sizeof(prec->phas);
    prt->papFldDes[ubyteRecordEVNT]->size = sizeof(prec->evnt);
    prt->papFldDes[ubyteRecordTSE]->size = sizeof(prec->tse);
    prt->papFldDes[ubyteRecordTSEL]->size = sizeof(prec->tsel);
    prt->papFldDes[ubyteRecordDTYP]->size = sizeof(prec->dtyp);
    prt->papFldDes[ubyteRecordDISV]->size = sizeof(prec->disv);
    prt->papFldDes[ubyteRecordDISA]->size = sizeof(prec->disa);
    prt->papFldDes[ubyteRecordSDIS]->size = sizeof(prec->sdis);
    prt->papFldDes[ubyteRecordMLOK]->size = sizeof(prec->mlok);
    prt->papFldDes[ubyteRecordMLIS]->size = sizeof(prec->mlis);
    prt->papFldDes[ubyteRecordDISP]->size = sizeof(prec->disp);
    prt->papFldDes[ubyteRecordPROC]->size = sizeof(prec->proc);
    prt->papFldDes[ubyteRecordSTAT]->size = sizeof(prec->stat);
    prt->papFldDes[ubyteRecordSEVR]->size = sizeof(prec->sevr);
    prt->papFldDes[ubyteRecordNSTA]->size = sizeof(prec->nsta);
    prt->papFldDes[ubyteRecordNSEV]->size = sizeof(prec->nsev);
    prt->papFldDes[ubyteRecordACKS]->size = sizeof(prec->acks);
    prt->papFldDes[ubyteRecordACKT]->size = sizeof(prec->ackt);
    prt->papFldDes[ubyteRecordDISS]->size = sizeof(prec->diss);
    prt->papFldDes[ubyteRecordLCNT]->size = sizeof(prec->lcnt);
    prt->papFldDes[ubyteRecordPACT]->size = sizeof(prec->pact);
    prt->papFldDes[ubyteRecordPUTF]->size = sizeof(prec->putf);
    prt->papFldDes[ubyteRecordRPRO]->size = sizeof(prec->rpro);
    prt->papFldDes[ubyteRecordASP]->size = sizeof(prec->asp);
    prt->papFldDes[ubyteRecordPPN]->size = sizeof(prec->ppn);
    prt->papFldDes[ubyteRecordPPNR]->size = sizeof(prec->ppnr);
    prt->papFldDes[ubyteRecordSPVT]->size = sizeof(prec->spvt);
    prt->papFldDes[ubyteRecordRSET]->size = sizeof(prec->rset);
    prt->papFldDes[ubyteRecordDSET]->size = sizeof(prec->dset);
    prt->papFldDes[ubyteRecordDPVT]->size = sizeof(prec->dpvt);
    prt->papFldDes[ubyteRecordRDES]->size = sizeof(prec->rdes);
    prt->papFldDes[ubyteRecordLSET]->size = sizeof(prec->lset);
    prt->papFldDes[ubyteRecordPRIO]->size = sizeof(prec->prio);
    prt->papFldDes[ubyteRecordTPRO]->size = sizeof(prec->tpro);
    prt->papFldDes[ubyteRecordBKPT]->size = sizeof(prec->bkpt);
    prt->papFldDes[ubyteRecordUDF]->size = sizeof(prec->udf);
    prt->papFldDes[ubyteRecordUDFS]->size = sizeof(prec->udfs);
    prt->papFldDes[ubyteRecordTIME]->size = sizeof(prec->time);
    prt->papFldDes[ubyteRecordFLNK]->size = sizeof(prec->flnk);
    prt->papFldDes[ubyteRecordVAL]->size = sizeof(prec->val);
    prt->papFldDes[ubyteRecordPREC]->size = sizeof(prec->prec);
    prt->papFldDes[ubyteRecordEGU]->size = sizeof(prec->egu);
    prt->papFldDes[ubyteRecordHOPR]->size = sizeof(prec->hopr);
    prt->papFldDes[ubyteRecordLOPR]->size = sizeof(prec->lopr);
    prt->papFldDes[ubyteRecordDRVH]->size = sizeof(prec->drvh);
    prt->papFldDes[ubyteRecordDRVL]->size = sizeof(prec->drvl);
    prt->papFldDes[ubyteRecordHIHI]->size = sizeof(prec->hihi);
    prt->papFldDes[ubyteRecordLOLO]->size = sizeof(prec->lolo);
    prt->papFldDes[ubyteRecordHIGH]->size = sizeof(prec->high);
    prt->papFldDes[ubyteRecordLOW]->size = sizeof(prec->low);
    prt->papFldDes[ubyteRecordHHSV]->size = sizeof(prec->hhsv);
    prt->papFldDes[ubyteRecordLLSV]->size = sizeof(prec->llsv);
    prt->papFldDes[ubyteRecordHSV]->size = sizeof(prec->hsv);
    prt->papFldDes[ubyteRecordLSV]->size = sizeof(prec->lsv);
    prt->papFldDes[ubyteRecordHYST]->size = sizeof(prec->hyst);
    prt->papFldDes[ubyteRecordADEL]->size = sizeof(prec->adel);
    prt->papFldDes[ubyteRecordMDEL]->size = sizeof(prec->mdel);
    prt->papFldDes[ubyteRecordLALM]->size = sizeof(prec->lalm);
    prt->papFldDes[ubyteRecordALST]->size = sizeof(prec->alst);
    prt->papFldDes[ubyteRecordMLST]->size = sizeof(prec->mlst);
    prt->papFldDes[ubyteRecordNAME]->offset = (unsigned short)((char *)&prec->name - (char *)prec);
    prt->papFldDes[ubyteRecordDESC]->offset = (unsigned short)((char *)&prec->desc - (char *)prec);
    prt->papFldDes[ubyteRecordASG]->offset = (unsigned short)((char *)&prec->asg - (char *)prec);
    prt->papFldDes[ubyteRecordSCAN]->offset = (unsigned short)((char *)&prec->scan - (char *)prec);
    prt->papFldDes[ubyteRecordPINI]->offset = (unsigned short)((char *)&prec->pini - (char *)prec);
    prt->papFldDes[ubyteRecordPHAS]->offset = (unsigned short)((char *)&prec->phas - (char *)prec);
    prt->papFldDes[ubyteRecordEVNT]->offset = (unsigned short)((char *)&prec->evnt - (char *)prec);
    prt->papFldDes[ubyteRecordTSE]->offset = (unsigned short)((char *)&prec->tse - (char *)prec);
    prt->papFldDes[ubyteRecordTSEL]->offset = (unsigned short)((char *)&prec->tsel - (char *)prec);
    prt->papFldDes[ubyteRecordDTYP]->offset = (unsigned short)((char *)&prec->dtyp - (char *)prec);
    prt->papFldDes[ubyteRecordDISV]->offset = (unsigned short)((char *)&prec->disv - (char *)prec);
    prt->papFldDes[ubyteRecordDISA]->offset = (unsigned short)((char *)&prec->disa - (char *)prec);
    prt->papFldDes[ubyteRecordSDIS]->offset = (unsigned short)((char *)&prec->sdis - (char *)prec);
    prt->papFldDes[ubyteRecordMLOK]->offset = (unsigned short)((char *)&prec->mlok - (char *)prec);
    prt->papFldDes[ubyteRecordMLIS]->offset = (unsigned short)((char *)&prec->mlis - (char *)prec);
    prt->papFldDes[ubyteRecordDISP]->offset = (unsigned short)((char *)&prec->disp - (char *)prec);
    prt->papFldDes[ubyteRecordPROC]->offset = (unsigned short)((char *)&prec->proc - (char *)prec);
    prt->papFldDes[ubyteRecordSTAT]->offset = (unsigned short)((char *)&prec->stat - (char *)prec);
    prt->papFldDes[ubyteRecordSEVR]->offset = (unsigned short)((char *)&prec->sevr - (char *)prec);
    prt->papFldDes[ubyteRecordNSTA]->offset = (unsigned short)((char *)&prec->nsta - (char *)prec);
    prt->papFldDes[ubyteRecordNSEV]->offset = (unsigned short)((char *)&prec->nsev - (char *)prec);
    prt->papFldDes[ubyteRecordACKS]->offset = (unsigned short)((char *)&prec->acks - (char *)prec);
    prt->papFldDes[ubyteRecordACKT]->offset = (unsigned short)((char *)&prec->ackt - (char *)prec);
    prt->papFldDes[ubyteRecordDISS]->offset = (unsigned short)((char *)&prec->diss - (char *)prec);
    prt->papFldDes[ubyteRecordLCNT]->offset = (unsigned short)((char *)&prec->lcnt - (char *)prec);
    prt->papFldDes[ubyteRecordPACT]->offset = (unsigned short)((char *)&prec->pact - (char *)prec);
    prt->papFldDes[ubyteRecordPUTF]->offset = (unsigned short)((char *)&prec->putf - (char *)prec);
    prt->papFldDes[ubyteRecordRPRO]->offset = (unsigned short)((char *)&prec->rpro - (char *)prec);
    prt->papFldDes[ubyteRecordASP]->offset = (unsigned short)((char *)&prec->asp - (char *)prec);
    prt->papFldDes[ubyteRecordPPN]->offset = (unsigned short)((char *)&prec->ppn - (char *)prec);
    prt->papFldDes[ubyteRecordPPNR]->offset = (unsigned short)((char *)&prec->ppnr - (char *)prec);
    prt->papFldDes[ubyteRecordSPVT]->offset = (unsigned short)((char *)&prec->spvt - (char *)prec);
    prt->papFldDes[ubyteRecordRSET]->offset = (unsigned short)((char *)&prec->rset - (char *)prec);
    prt->papFldDes[ubyteRecordDSET]->offset = (unsigned short)((char *)&prec->dset - (char *)prec);
    prt->papFldDes[ubyteRecordDPVT]->offset = (unsigned short)((char *)&prec->dpvt - (char *)prec);
    prt->papFldDes[ubyteRecordRDES]->offset = (unsigned short)((char *)&prec->rdes - (char *)prec);
    prt->papFldDes[ubyteRecordLSET]->offset = (unsigned short)((char *)&prec->lset - (char *)prec);
    prt->papFldDes[ubyteRecordPRIO]->offset = (unsigned short)((char *)&prec->prio - (char *)prec);
    prt->papFldDes[ubyteRecordTPRO]->offset = (unsigned short)((char *)&prec->tpro - (char *)prec);
    prt->papFldDes[ubyteRecordBKPT]->offset = (unsigned short)((char *)&prec->bkpt - (char *)prec);
    prt->papFldDes[ubyteRecordUDF]->offset = (unsigned short)((char *)&prec->udf - (char *)prec);
    prt->papFldDes[ubyteRecordUDFS]->offset = (unsigned short)((char *)&prec->udfs - (char *)prec);
    prt->papFldDes[ubyteRecordTIME]->offset = (unsigned short)((char *)&prec->time - (char *)prec);
    prt->papFldDes[ubyteRecordFLNK]->offset = (unsigned short)((char *)&prec->flnk - (char *)prec);
    prt->papFldDes[ubyteRecordVAL]->offset = (unsigned short)((char *)&prec->val - (char *)prec);
    prt->papFldDes[ubyteRecordPREC]->offset = (unsigned short)((char *)&prec->prec - (char *)prec);
    prt->papFldDes[ubyteRecordEGU]->offset = (unsigned short)((char *)&prec->egu - (char *)prec);
    prt->papFldDes[ubyteRecordHOPR]->offset = (unsigned short)((char *)&prec->hopr - (char *)prec);
    prt->papFldDes[ubyteRecordLOPR]->offset = (unsigned short)((char *)&prec->lopr - (char *)prec);
    prt->papFldDes[ubyteRecordDRVH]->offset = (unsigned short)((char *)&prec->drvh - (char *)prec);
    prt->papFldDes[ubyteRecordDRVL]->offset = (unsigned short)((char *)&prec->drvl - (char *)prec);
    prt->papFldDes[ubyteRecordHIHI]->offset = (unsigned short)((char *)&prec->hihi - (char *)prec);
    prt->papFldDes[ubyteRecordLOLO]->offset = (unsigned short)((char *)&prec->lolo - (char *)prec);
    prt->papFldDes[ubyteRecordHIGH]->offset = (unsigned short)((char *)&prec->high - (char *)prec);
    prt->papFldDes[ubyteRecordLOW]->offset = (unsigned short)((char *)&prec->low - (char *)prec);
    prt->papFldDes[ubyteRecordHHSV]->offset = (unsigned short)((char *)&prec->hhsv - (char *)prec);
    prt->papFldDes[ubyteRecordLLSV]->offset = (unsigned short)((char *)&prec->llsv - (char *)prec);
    prt->papFldDes[ubyteRecordHSV]->offset = (unsigned short)((char *)&prec->hsv - (char *)prec);
    prt->papFldDes[ubyteRecordLSV]->offset = (unsigned short)((char *)&prec->lsv - (char *)prec);
    prt->papFldDes[ubyteRecordHYST]->offset = (unsigned short)((char *)&prec->hyst - (char *)prec);
    prt->papFldDes[ubyteRecordADEL]->offset = (unsigned short)((char *)&prec->adel - (char *)prec);
    prt->papFldDes[ubyteRecordMDEL]->offset = (unsigned short)((char *)&prec->mdel - (char *)prec);
    prt->papFldDes[ubyteRecordLALM]->offset = (unsigned short)((char *)&prec->lalm - (char *)prec);
    prt->papFldDes[ubyteRecordALST]->offset = (unsigned short)((char *)&prec->alst - (char *)prec);
    prt->papFldDes[ubyteRecordMLST]->offset = (unsigned short)((char *)&prec->mlst - (char *)prec);
    prt->rec_size = sizeof(*prec);
    return 0;
}
epicsExportRegistrar(ubyteRecordSizeOffset);

#ifdef __cplusplus
}
#endif
#endif /* GEN_SIZE_OFFSET */

#endif /* INC_ubyteRecord_H */
