/* ulongRecord.h generated from ulongRecord.dbd */

#ifndef INC_ulongRecord_H
#define INC_ulongRecord_H

#include "epicsTypes.h"
#include "link.h"
#include "epicsMutex.h"
#include "ellLib.h"
#include "epicsTime.h"

typedef struct ulongRecord {
    char                name[61];   /* Record Name */
    char                desc[41];   /* Descriptor */
    char                asg[29];    /* Access Security Group */
    epicsEnum16         scan;       /* Scan Mechanism */
    epicsEnum16         pini;       /* Process at iocInit */
    epicsInt16          phas;       /* Scan Phase */
    char                evnt[40];   /* Event Name */
    epicsInt16          tse;        /* Time Stamp Event */
    DBLINK              tsel;       /* Time Stamp Link */
    epicsEnum16         dtyp;       /* Device Type */
    epicsInt16          disv;       /* Disable Value */
    epicsInt16          disa;       /* Disable */
    DBLINK              sdis;       /* Scanning Disable */
    epicsMutexId        mlok;       /* Monitor lock */
    ELLLIST             mlis;       /* Monitor List */
    epicsUInt8          disp;       /* Disable putField */
    epicsUInt8          proc;       /* Force Processing */
    epicsEnum16         stat;       /* Alarm Status */
    epicsEnum16         sevr;       /* Alarm Severity */
    epicsEnum16         nsta;       /* New Alarm Status */
    epicsEnum16         nsev;       /* New Alarm Severity */
    epicsEnum16         acks;       /* Alarm Ack Severity */
    epicsEnum16         ackt;       /* Alarm Ack Transient */
    epicsEnum16         diss;       /* Disable Alarm Sevrty */
    epicsUInt8          lcnt;       /* Lock Count */
    epicsUInt8          pact;       /* Record active */
    epicsUInt8          putf;       /* dbPutField process */
    epicsUInt8          rpro;       /* Reprocess  */
    struct asgMember    *asp;       /* Access Security Pvt */
    struct processNotify *ppn;      /* pprocessNotify */
    struct processNotifyRecord *ppnr; /* pprocessNotifyRecord */
    struct scan_element *spvt;      /* Scan Private */
    struct rset         *rset;      /* Address of RSET */
    struct dset         *dset;      /* DSET address */
    void                *dpvt;      /* Device Private */
    struct dbRecordType *rdes;      /* Address of dbRecordType */
    struct lockRecord   *lset;      /* Lock Set */
    epicsEnum16         prio;       /* Scheduling Priority */
    epicsUInt8          tpro;       /* Trace Processing */
    char                bkpt;       /* Break Point */
    epicsUInt8          udf;        /* Undefined */
    epicsEnum16         udfs;       /* Undefined Alarm Sevrty */
    epicsTimeStamp      time;       /* Time */
    DBLINK              flnk;       /* Forward Process Link */
    epicsUInt32         val;        /* Current EGU Value */
    epicsUInt32         prec;       /* Display Precision */
    char                egu[16];    /* Engineering Units */
    epicsUInt32         hopr;       /* High Operating Range */
    epicsUInt32         lopr;       /* Low Operating Range */
    epicsUInt32         drvh;       /* High Operating Range */
    epicsUInt32         drvl;       /* Low Operating Range */
    epicsUInt32         hihi;       /* Hihi Alarm Limit */
    epicsUInt32         lolo;       /* Lolo Alarm Limit */
    epicsUInt32         high;       /* High Alarm Limit */
    epicsUInt32         low;        /* Low Alarm Limit */
    epicsEnum16         hhsv;       /* Hihi Severity */
    epicsEnum16         llsv;       /* Lolo Severity */
    epicsEnum16         hsv;        /* High Severity */
    epicsEnum16         lsv;        /* Low Severity */
    epicsUInt32         hyst;       /* Alarm Deadband */
    epicsUInt32         adel;       /* Archive Deadband */
    epicsUInt32         mdel;       /* Monitor Deadband */
    epicsUInt32         lalm;       /* Last Value Alarmed */
    epicsUInt32         alst;       /* Last Value Archived */
    epicsUInt32         mlst;       /* Last Val Monitored */
} ulongRecord;

typedef enum {
	ulongRecordNAME = 0,
	ulongRecordDESC = 1,
	ulongRecordASG = 2,
	ulongRecordSCAN = 3,
	ulongRecordPINI = 4,
	ulongRecordPHAS = 5,
	ulongRecordEVNT = 6,
	ulongRecordTSE = 7,
	ulongRecordTSEL = 8,
	ulongRecordDTYP = 9,
	ulongRecordDISV = 10,
	ulongRecordDISA = 11,
	ulongRecordSDIS = 12,
	ulongRecordMLOK = 13,
	ulongRecordMLIS = 14,
	ulongRecordDISP = 15,
	ulongRecordPROC = 16,
	ulongRecordSTAT = 17,
	ulongRecordSEVR = 18,
	ulongRecordNSTA = 19,
	ulongRecordNSEV = 20,
	ulongRecordACKS = 21,
	ulongRecordACKT = 22,
	ulongRecordDISS = 23,
	ulongRecordLCNT = 24,
	ulongRecordPACT = 25,
	ulongRecordPUTF = 26,
	ulongRecordRPRO = 27,
	ulongRecordASP = 28,
	ulongRecordPPN = 29,
	ulongRecordPPNR = 30,
	ulongRecordSPVT = 31,
	ulongRecordRSET = 32,
	ulongRecordDSET = 33,
	ulongRecordDPVT = 34,
	ulongRecordRDES = 35,
	ulongRecordLSET = 36,
	ulongRecordPRIO = 37,
	ulongRecordTPRO = 38,
	ulongRecordBKPT = 39,
	ulongRecordUDF = 40,
	ulongRecordUDFS = 41,
	ulongRecordTIME = 42,
	ulongRecordFLNK = 43,
	ulongRecordVAL = 44,
	ulongRecordPREC = 45,
	ulongRecordEGU = 46,
	ulongRecordHOPR = 47,
	ulongRecordLOPR = 48,
	ulongRecordDRVH = 49,
	ulongRecordDRVL = 50,
	ulongRecordHIHI = 51,
	ulongRecordLOLO = 52,
	ulongRecordHIGH = 53,
	ulongRecordLOW = 54,
	ulongRecordHHSV = 55,
	ulongRecordLLSV = 56,
	ulongRecordHSV = 57,
	ulongRecordLSV = 58,
	ulongRecordHYST = 59,
	ulongRecordADEL = 60,
	ulongRecordMDEL = 61,
	ulongRecordLALM = 62,
	ulongRecordALST = 63,
	ulongRecordMLST = 64
} ulongFieldIndex;

#ifdef GEN_SIZE_OFFSET

#include <epicsAssert.h>
#include <epicsExport.h>
#ifdef __cplusplus
extern "C" {
#endif
static int ulongRecordSizeOffset(dbRecordType *prt)
{
    ulongRecord *prec = 0;

    assert(prt->no_fields == 65);
    prt->papFldDes[ulongRecordNAME]->size = sizeof(prec->name);
    prt->papFldDes[ulongRecordDESC]->size = sizeof(prec->desc);
    prt->papFldDes[ulongRecordASG]->size = sizeof(prec->asg);
    prt->papFldDes[ulongRecordSCAN]->size = sizeof(prec->scan);
    prt->papFldDes[ulongRecordPINI]->size = sizeof(prec->pini);
    prt->papFldDes[ulongRecordPHAS]->size = sizeof(prec->phas);
    prt->papFldDes[ulongRecordEVNT]->size = sizeof(prec->evnt);
    prt->papFldDes[ulongRecordTSE]->size = sizeof(prec->tse);
    prt->papFldDes[ulongRecordTSEL]->size = sizeof(prec->tsel);
    prt->papFldDes[ulongRecordDTYP]->size = sizeof(prec->dtyp);
    prt->papFldDes[ulongRecordDISV]->size = sizeof(prec->disv);
    prt->papFldDes[ulongRecordDISA]->size = sizeof(prec->disa);
    prt->papFldDes[ulongRecordSDIS]->size = sizeof(prec->sdis);
    prt->papFldDes[ulongRecordMLOK]->size = sizeof(prec->mlok);
    prt->papFldDes[ulongRecordMLIS]->size = sizeof(prec->mlis);
    prt->papFldDes[ulongRecordDISP]->size = sizeof(prec->disp);
    prt->papFldDes[ulongRecordPROC]->size = sizeof(prec->proc);
    prt->papFldDes[ulongRecordSTAT]->size = sizeof(prec->stat);
    prt->papFldDes[ulongRecordSEVR]->size = sizeof(prec->sevr);
    prt->papFldDes[ulongRecordNSTA]->size = sizeof(prec->nsta);
    prt->papFldDes[ulongRecordNSEV]->size = sizeof(prec->nsev);
    prt->papFldDes[ulongRecordACKS]->size = sizeof(prec->acks);
    prt->papFldDes[ulongRecordACKT]->size = sizeof(prec->ackt);
    prt->papFldDes[ulongRecordDISS]->size = sizeof(prec->diss);
    prt->papFldDes[ulongRecordLCNT]->size = sizeof(prec->lcnt);
    prt->papFldDes[ulongRecordPACT]->size = sizeof(prec->pact);
    prt->papFldDes[ulongRecordPUTF]->size = sizeof(prec->putf);
    prt->papFldDes[ulongRecordRPRO]->size = sizeof(prec->rpro);
    prt->papFldDes[ulongRecordASP]->size = sizeof(prec->asp);
    prt->papFldDes[ulongRecordPPN]->size = sizeof(prec->ppn);
    prt->papFldDes[ulongRecordPPNR]->size = sizeof(prec->ppnr);
    prt->papFldDes[ulongRecordSPVT]->size = sizeof(prec->spvt);
    prt->papFldDes[ulongRecordRSET]->size = sizeof(prec->rset);
    prt->papFldDes[ulongRecordDSET]->size = sizeof(prec->dset);
    prt->papFldDes[ulongRecordDPVT]->size = sizeof(prec->dpvt);
    prt->papFldDes[ulongRecordRDES]->size = sizeof(prec->rdes);
    prt->papFldDes[ulongRecordLSET]->size = sizeof(prec->lset);
    prt->papFldDes[ulongRecordPRIO]->size = sizeof(prec->prio);
    prt->papFldDes[ulongRecordTPRO]->size = sizeof(prec->tpro);
    prt->papFldDes[ulongRecordBKPT]->size = sizeof(prec->bkpt);
    prt->papFldDes[ulongRecordUDF]->size = sizeof(prec->udf);
    prt->papFldDes[ulongRecordUDFS]->size = sizeof(prec->udfs);
    prt->papFldDes[ulongRecordTIME]->size = sizeof(prec->time);
    prt->papFldDes[ulongRecordFLNK]->size = sizeof(prec->flnk);
    prt->papFldDes[ulongRecordVAL]->size = sizeof(prec->val);
    prt->papFldDes[ulongRecordPREC]->size = sizeof(prec->prec);
    prt->papFldDes[ulongRecordEGU]->size = sizeof(prec->egu);
    prt->papFldDes[ulongRecordHOPR]->size = sizeof(prec->hopr);
    prt->papFldDes[ulongRecordLOPR]->size = sizeof(prec->lopr);
    prt->papFldDes[ulongRecordDRVH]->size = sizeof(prec->drvh);
    prt->papFldDes[ulongRecordDRVL]->size = sizeof(prec->drvl);
    prt->papFldDes[ulongRecordHIHI]->size = sizeof(prec->hihi);
    prt->papFldDes[ulongRecordLOLO]->size = sizeof(prec->lolo);
    prt->papFldDes[ulongRecordHIGH]->size = sizeof(prec->high);
    prt->papFldDes[ulongRecordLOW]->size = sizeof(prec->low);
    prt->papFldDes[ulongRecordHHSV]->size = sizeof(prec->hhsv);
    prt->papFldDes[ulongRecordLLSV]->size = sizeof(prec->llsv);
    prt->papFldDes[ulongRecordHSV]->size = sizeof(prec->hsv);
    prt->papFldDes[ulongRecordLSV]->size = sizeof(prec->lsv);
    prt->papFldDes[ulongRecordHYST]->size = sizeof(prec->hyst);
    prt->papFldDes[ulongRecordADEL]->size = sizeof(prec->adel);
    prt->papFldDes[ulongRecordMDEL]->size = sizeof(prec->mdel);
    prt->papFldDes[ulongRecordLALM]->size = sizeof(prec->lalm);
    prt->papFldDes[ulongRecordALST]->size = sizeof(prec->alst);
    prt->papFldDes[ulongRecordMLST]->size = sizeof(prec->mlst);
    prt->papFldDes[ulongRecordNAME]->offset = (unsigned short)((char *)&prec->name - (char *)prec);
    prt->papFldDes[ulongRecordDESC]->offset = (unsigned short)((char *)&prec->desc - (char *)prec);
    prt->papFldDes[ulongRecordASG]->offset = (unsigned short)((char *)&prec->asg - (char *)prec);
    prt->papFldDes[ulongRecordSCAN]->offset = (unsigned short)((char *)&prec->scan - (char *)prec);
    prt->papFldDes[ulongRecordPINI]->offset = (unsigned short)((char *)&prec->pini - (char *)prec);
    prt->papFldDes[ulongRecordPHAS]->offset = (unsigned short)((char *)&prec->phas - (char *)prec);
    prt->papFldDes[ulongRecordEVNT]->offset = (unsigned short)((char *)&prec->evnt - (char *)prec);
    prt->papFldDes[ulongRecordTSE]->offset = (unsigned short)((char *)&prec->tse - (char *)prec);
    prt->papFldDes[ulongRecordTSEL]->offset = (unsigned short)((char *)&prec->tsel - (char *)prec);
    prt->papFldDes[ulongRecordDTYP]->offset = (unsigned short)((char *)&prec->dtyp - (char *)prec);
    prt->papFldDes[ulongRecordDISV]->offset = (unsigned short)((char *)&prec->disv - (char *)prec);
    prt->papFldDes[ulongRecordDISA]->offset = (unsigned short)((char *)&prec->disa - (char *)prec);
    prt->papFldDes[ulongRecordSDIS]->offset = (unsigned short)((char *)&prec->sdis - (char *)prec);
    prt->papFldDes[ulongRecordMLOK]->offset = (unsigned short)((char *)&prec->mlok - (char *)prec);
    prt->papFldDes[ulongRecordMLIS]->offset = (unsigned short)((char *)&prec->mlis - (char *)prec);
    prt->papFldDes[ulongRecordDISP]->offset = (unsigned short)((char *)&prec->disp - (char *)prec);
    prt->papFldDes[ulongRecordPROC]->offset = (unsigned short)((char *)&prec->proc - (char *)prec);
    prt->papFldDes[ulongRecordSTAT]->offset = (unsigned short)((char *)&prec->stat - (char *)prec);
    prt->papFldDes[ulongRecordSEVR]->offset = (unsigned short)((char *)&prec->sevr - (char *)prec);
    prt->papFldDes[ulongRecordNSTA]->offset = (unsigned short)((char *)&prec->nsta - (char *)prec);
    prt->papFldDes[ulongRecordNSEV]->offset = (unsigned short)((char *)&prec->nsev - (char *)prec);
    prt->papFldDes[ulongRecordACKS]->offset = (unsigned short)((char *)&prec->acks - (char *)prec);
    prt->papFldDes[ulongRecordACKT]->offset = (unsigned short)((char *)&prec->ackt - (char *)prec);
    prt->papFldDes[ulongRecordDISS]->offset = (unsigned short)((char *)&prec->diss - (char *)prec);
    prt->papFldDes[ulongRecordLCNT]->offset = (unsigned short)((char *)&prec->lcnt - (char *)prec);
    prt->papFldDes[ulongRecordPACT]->offset = (unsigned short)((char *)&prec->pact - (char *)prec);
    prt->papFldDes[ulongRecordPUTF]->offset = (unsigned short)((char *)&prec->putf - (char *)prec);
    prt->papFldDes[ulongRecordRPRO]->offset = (unsigned short)((char *)&prec->rpro - (char *)prec);
    prt->papFldDes[ulongRecordASP]->offset = (unsigned short)((char *)&prec->asp - (char *)prec);
    prt->papFldDes[ulongRecordPPN]->offset = (unsigned short)((char *)&prec->ppn - (char *)prec);
    prt->papFldDes[ulongRecordPPNR]->offset = (unsigned short)((char *)&prec->ppnr - (char *)prec);
    prt->papFldDes[ulongRecordSPVT]->offset = (unsigned short)((char *)&prec->spvt - (char *)prec);
    prt->papFldDes[ulongRecordRSET]->offset = (unsigned short)((char *)&prec->rset - (char *)prec);
    prt->papFldDes[ulongRecordDSET]->offset = (unsigned short)((char *)&prec->dset - (char *)prec);
    prt->papFldDes[ulongRecordDPVT]->offset = (unsigned short)((char *)&prec->dpvt - (char *)prec);
    prt->papFldDes[ulongRecordRDES]->offset = (unsigned short)((char *)&prec->rdes - (char *)prec);
    prt->papFldDes[ulongRecordLSET]->offset = (unsigned short)((char *)&prec->lset - (char *)prec);
    prt->papFldDes[ulongRecordPRIO]->offset = (unsigned short)((char *)&prec->prio - (char *)prec);
    prt->papFldDes[ulongRecordTPRO]->offset = (unsigned short)((char *)&prec->tpro - (char *)prec);
    prt->papFldDes[ulongRecordBKPT]->offset = (unsigned short)((char *)&prec->bkpt - (char *)prec);
    prt->papFldDes[ulongRecordUDF]->offset = (unsigned short)((char *)&prec->udf - (char *)prec);
    prt->papFldDes[ulongRecordUDFS]->offset = (unsigned short)((char *)&prec->udfs - (char *)prec);
    prt->papFldDes[ulongRecordTIME]->offset = (unsigned short)((char *)&prec->time - (char *)prec);
    prt->papFldDes[ulongRecordFLNK]->offset = (unsigned short)((char *)&prec->flnk - (char *)prec);
    prt->papFldDes[ulongRecordVAL]->offset = (unsigned short)((char *)&prec->val - (char *)prec);
    prt->papFldDes[ulongRecordPREC]->offset = (unsigned short)((char *)&prec->prec - (char *)prec);
    prt->papFldDes[ulongRecordEGU]->offset = (unsigned short)((char *)&prec->egu - (char *)prec);
    prt->papFldDes[ulongRecordHOPR]->offset = (unsigned short)((char *)&prec->hopr - (char *)prec);
    prt->papFldDes[ulongRecordLOPR]->offset = (unsigned short)((char *)&prec->lopr - (char *)prec);
    prt->papFldDes[ulongRecordDRVH]->offset = (unsigned short)((char *)&prec->drvh - (char *)prec);
    prt->papFldDes[ulongRecordDRVL]->offset = (unsigned short)((char *)&prec->drvl - (char *)prec);
    prt->papFldDes[ulongRecordHIHI]->offset = (unsigned short)((char *)&prec->hihi - (char *)prec);
    prt->papFldDes[ulongRecordLOLO]->offset = (unsigned short)((char *)&prec->lolo - (char *)prec);
    prt->papFldDes[ulongRecordHIGH]->offset = (unsigned short)((char *)&prec->high - (char *)prec);
    prt->papFldDes[ulongRecordLOW]->offset = (unsigned short)((char *)&prec->low - (char *)prec);
    prt->papFldDes[ulongRecordHHSV]->offset = (unsigned short)((char *)&prec->hhsv - (char *)prec);
    prt->papFldDes[ulongRecordLLSV]->offset = (unsigned short)((char *)&prec->llsv - (char *)prec);
    prt->papFldDes[ulongRecordHSV]->offset = (unsigned short)((char *)&prec->hsv - (char *)prec);
    prt->papFldDes[ulongRecordLSV]->offset = (unsigned short)((char *)&prec->lsv - (char *)prec);
    prt->papFldDes[ulongRecordHYST]->offset = (unsigned short)((char *)&prec->hyst - (char *)prec);
    prt->papFldDes[ulongRecordADEL]->offset = (unsigned short)((char *)&prec->adel - (char *)prec);
    prt->papFldDes[ulongRecordMDEL]->offset = (unsigned short)((char *)&prec->mdel - (char *)prec);
    prt->papFldDes[ulongRecordLALM]->offset = (unsigned short)((char *)&prec->lalm - (char *)prec);
    prt->papFldDes[ulongRecordALST]->offset = (unsigned short)((char *)&prec->alst - (char *)prec);
    prt->papFldDes[ulongRecordMLST]->offset = (unsigned short)((char *)&prec->mlst - (char *)prec);
    prt->rec_size = sizeof(*prec);
    return 0;
}
epicsExportRegistrar(ulongRecordSizeOffset);

#ifdef __cplusplus
}
#endif
#endif /* GEN_SIZE_OFFSET */

#endif /* INC_ulongRecord_H */
