/* waitRecord.h generated from waitRecord.dbd */

#ifndef INC_waitRecord_H
#define INC_waitRecord_H

#include "epicsTypes.h"
#include "link.h"
#include "epicsMutex.h"
#include "ellLib.h"
#include "epicsTime.h"

typedef struct waitRecord {
    char                name[61];   /* Record Name */
    char                desc[41];   /* Descriptor */
    char                asg[29];    /* Access Security Group */
    epicsEnum16         scan;       /* Scan Mechanism */
    epicsEnum16         pini;       /* Process at iocInit */
    epicsInt16          phas;       /* Scan Phase */
    char                evnt[40];   /* Event Name */
    epicsInt16          tse;        /* Time Stamp Event */
    DBLINK              tsel;       /* Time Stamp Link */
    epicsEnum16         dtyp;       /* Device Type */
    epicsInt16          disv;       /* Disable Value */
    epicsInt16          disa;       /* Disable */
    DBLINK              sdis;       /* Scanning Disable */
    epicsMutexId        mlok;       /* Monitor lock */
    ELLLIST             mlis;       /* Monitor List */
    epicsUInt8          disp;       /* Disable putField */
    epicsUInt8          proc;       /* Force Processing */
    epicsEnum16         stat;       /* Alarm Status */
    epicsEnum16         sevr;       /* Alarm Severity */
    epicsEnum16         nsta;       /* New Alarm Status */
    epicsEnum16         nsev;       /* New Alarm Severity */
    epicsEnum16         acks;       /* Alarm Ack Severity */
    epicsEnum16         ackt;       /* Alarm Ack Transient */
    epicsEnum16         diss;       /* Disable Alarm Sevrty */
    epicsUInt8          lcnt;       /* Lock Count */
    epicsUInt8          pact;       /* Record active */
    epicsUInt8          putf;       /* dbPutField process */
    epicsUInt8          rpro;       /* Reprocess  */
    struct asgMember    *asp;       /* Access Security Pvt */
    struct processNotify *ppn;      /* pprocessNotify */
    struct processNotifyRecord *ppnr; /* pprocessNotifyRecord */
    struct scan_element *spvt;      /* Scan Private */
    struct rset         *rset;      /* Address of RSET */
    struct dset         *dset;      /* DSET address */
    void                *dpvt;      /* Device Private */
    struct dbRecordType *rdes;      /* Address of dbRecordType */
    struct lockRecord   *lset;      /* Lock Set */
    epicsEnum16         prio;       /* Scheduling Priority */
    epicsUInt8          tpro;       /* Trace Processing */
    char                bkpt;       /* Break Point */
    epicsUInt8          udf;        /* Undefined */
    epicsEnum16         udfs;       /* Undefined Alarm Sevrty */
    epicsTimeStamp      time;       /* Time */
    DBLINK              flnk;       /* Forward Process Link */
    epicsInt16          val;        /* Current EGU Value */
    epicsInt16          prec;       /* Display Precision */
    char                egu[16];    /* Engineering Units */
    epicsInt16          hopr;       /* High Operating Range */
    epicsInt16          lopr;       /* Low Operating Range */
    epicsInt16          drvh;       /* High Operating Range */
    epicsInt16          drvl;       /* Low Operating Range */
    epicsInt16          hihi;       /* Hihi Alarm Limit */
    epicsInt16          lolo;       /* Lolo Alarm Limit */
    epicsInt16          high;       /* High Alarm Limit */
    epicsInt16          low;        /* Low Alarm Limit */
    epicsEnum16         hhsv;       /* Hihi Severity */
    epicsEnum16         llsv;       /* Lolo Severity */
    epicsEnum16         hsv;        /* High Severity */
    epicsEnum16         lsv;        /* Low Severity */
    epicsInt16          hyst;       /* Alarm Deadband */
    epicsInt16          adel;       /* Archive Deadband */
    epicsInt16          mdel;       /* Monitor Deadband */
    epicsInt16          lalm;       /* Last Value Alarmed */
    epicsInt16          alst;       /* Last Value Archived */
    epicsInt16          mlst;       /* Last Val Monitored */
} waitRecord;

typedef enum {
	waitRecordNAME = 0,
	waitRecordDESC = 1,
	waitRecordASG = 2,
	waitRecordSCAN = 3,
	waitRecordPINI = 4,
	waitRecordPHAS = 5,
	waitRecordEVNT = 6,
	waitRecordTSE = 7,
	waitRecordTSEL = 8,
	waitRecordDTYP = 9,
	waitRecordDISV = 10,
	waitRecordDISA = 11,
	waitRecordSDIS = 12,
	waitRecordMLOK = 13,
	waitRecordMLIS = 14,
	waitRecordDISP = 15,
	waitRecordPROC = 16,
	waitRecordSTAT = 17,
	waitRecordSEVR = 18,
	waitRecordNSTA = 19,
	waitRecordNSEV = 20,
	waitRecordACKS = 21,
	waitRecordACKT = 22,
	waitRecordDISS = 23,
	waitRecordLCNT = 24,
	waitRecordPACT = 25,
	waitRecordPUTF = 26,
	waitRecordRPRO = 27,
	waitRecordASP = 28,
	waitRecordPPN = 29,
	waitRecordPPNR = 30,
	waitRecordSPVT = 31,
	waitRecordRSET = 32,
	waitRecordDSET = 33,
	waitRecordDPVT = 34,
	waitRecordRDES = 35,
	waitRecordLSET = 36,
	waitRecordPRIO = 37,
	waitRecordTPRO = 38,
	waitRecordBKPT = 39,
	waitRecordUDF = 40,
	waitRecordUDFS = 41,
	waitRecordTIME = 42,
	waitRecordFLNK = 43,
	waitRecordVAL = 44,
	waitRecordPREC = 45,
	waitRecordEGU = 46,
	waitRecordHOPR = 47,
	waitRecordLOPR = 48,
	waitRecordDRVH = 49,
	waitRecordDRVL = 50,
	waitRecordHIHI = 51,
	waitRecordLOLO = 52,
	waitRecordHIGH = 53,
	waitRecordLOW = 54,
	waitRecordHHSV = 55,
	waitRecordLLSV = 56,
	waitRecordHSV = 57,
	waitRecordLSV = 58,
	waitRecordHYST = 59,
	waitRecordADEL = 60,
	waitRecordMDEL = 61,
	waitRecordLALM = 62,
	waitRecordALST = 63,
	waitRecordMLST = 64
} waitFieldIndex;

#ifdef GEN_SIZE_OFFSET

#include <epicsAssert.h>
#include <epicsExport.h>
#ifdef __cplusplus
extern "C" {
#endif
static int waitRecordSizeOffset(dbRecordType *prt)
{
    waitRecord *prec = 0;

    assert(prt->no_fields == 65);
    prt->papFldDes[waitRecordNAME]->size = sizeof(prec->name);
    prt->papFldDes[waitRecordDESC]->size = sizeof(prec->desc);
    prt->papFldDes[waitRecordASG]->size = sizeof(prec->asg);
    prt->papFldDes[waitRecordSCAN]->size = sizeof(prec->scan);
    prt->papFldDes[waitRecordPINI]->size = sizeof(prec->pini);
    prt->papFldDes[waitRecordPHAS]->size = sizeof(prec->phas);
    prt->papFldDes[waitRecordEVNT]->size = sizeof(prec->evnt);
    prt->papFldDes[waitRecordTSE]->size = sizeof(prec->tse);
    prt->papFldDes[waitRecordTSEL]->size = sizeof(prec->tsel);
    prt->papFldDes[waitRecordDTYP]->size = sizeof(prec->dtyp);
    prt->papFldDes[waitRecordDISV]->size = sizeof(prec->disv);
    prt->papFldDes[waitRecordDISA]->size = sizeof(prec->disa);
    prt->papFldDes[waitRecordSDIS]->size = sizeof(prec->sdis);
    prt->papFldDes[waitRecordMLOK]->size = sizeof(prec->mlok);
    prt->papFldDes[waitRecordMLIS]->size = sizeof(prec->mlis);
    prt->papFldDes[waitRecordDISP]->size = sizeof(prec->disp);
    prt->papFldDes[waitRecordPROC]->size = sizeof(prec->proc);
    prt->papFldDes[waitRecordSTAT]->size = sizeof(prec->stat);
    prt->papFldDes[waitRecordSEVR]->size = sizeof(prec->sevr);
    prt->papFldDes[waitRecordNSTA]->size = sizeof(prec->nsta);
    prt->papFldDes[waitRecordNSEV]->size = sizeof(prec->nsev);
    prt->papFldDes[waitRecordACKS]->size = sizeof(prec->acks);
    prt->papFldDes[waitRecordACKT]->size = sizeof(prec->ackt);
    prt->papFldDes[waitRecordDISS]->size = sizeof(prec->diss);
    prt->papFldDes[waitRecordLCNT]->size = sizeof(prec->lcnt);
    prt->papFldDes[waitRecordPACT]->size = sizeof(prec->pact);
    prt->papFldDes[waitRecordPUTF]->size = sizeof(prec->putf);
    prt->papFldDes[waitRecordRPRO]->size = sizeof(prec->rpro);
    prt->papFldDes[waitRecordASP]->size = sizeof(prec->asp);
    prt->papFldDes[waitRecordPPN]->size = sizeof(prec->ppn);
    prt->papFldDes[waitRecordPPNR]->size = sizeof(prec->ppnr);
    prt->papFldDes[waitRecordSPVT]->size = sizeof(prec->spvt);
    prt->papFldDes[waitRecordRSET]->size = sizeof(prec->rset);
    prt->papFldDes[waitRecordDSET]->size = sizeof(prec->dset);
    prt->papFldDes[waitRecordDPVT]->size = sizeof(prec->dpvt);
    prt->papFldDes[waitRecordRDES]->size = sizeof(prec->rdes);
    prt->papFldDes[waitRecordLSET]->size = sizeof(prec->lset);
    prt->papFldDes[waitRecordPRIO]->size = sizeof(prec->prio);
    prt->papFldDes[waitRecordTPRO]->size = sizeof(prec->tpro);
    prt->papFldDes[waitRecordBKPT]->size = sizeof(prec->bkpt);
    prt->papFldDes[waitRecordUDF]->size = sizeof(prec->udf);
    prt->papFldDes[waitRecordUDFS]->size = sizeof(prec->udfs);
    prt->papFldDes[waitRecordTIME]->size = sizeof(prec->time);
    prt->papFldDes[waitRecordFLNK]->size = sizeof(prec->flnk);
    prt->papFldDes[waitRecordVAL]->size = sizeof(prec->val);
    prt->papFldDes[waitRecordPREC]->size = sizeof(prec->prec);
    prt->papFldDes[waitRecordEGU]->size = sizeof(prec->egu);
    prt->papFldDes[waitRecordHOPR]->size = sizeof(prec->hopr);
    prt->papFldDes[waitRecordLOPR]->size = sizeof(prec->lopr);
    prt->papFldDes[waitRecordDRVH]->size = sizeof(prec->drvh);
    prt->papFldDes[waitRecordDRVL]->size = sizeof(prec->drvl);
    prt->papFldDes[waitRecordHIHI]->size = sizeof(prec->hihi);
    prt->papFldDes[waitRecordLOLO]->size = sizeof(prec->lolo);
    prt->papFldDes[waitRecordHIGH]->size = sizeof(prec->high);
    prt->papFldDes[waitRecordLOW]->size = sizeof(prec->low);
    prt->papFldDes[waitRecordHHSV]->size = sizeof(prec->hhsv);
    prt->papFldDes[waitRecordLLSV]->size = sizeof(prec->llsv);
    prt->papFldDes[waitRecordHSV]->size = sizeof(prec->hsv);
    prt->papFldDes[waitRecordLSV]->size = sizeof(prec->lsv);
    prt->papFldDes[waitRecordHYST]->size = sizeof(prec->hyst);
    prt->papFldDes[waitRecordADEL]->size = sizeof(prec->adel);
    prt->papFldDes[waitRecordMDEL]->size = sizeof(prec->mdel);
    prt->papFldDes[waitRecordLALM]->size = sizeof(prec->lalm);
    prt->papFldDes[waitRecordALST]->size = sizeof(prec->alst);
    prt->papFldDes[waitRecordMLST]->size = sizeof(prec->mlst);
    prt->papFldDes[waitRecordNAME]->offset = (unsigned short)((char *)&prec->name - (char *)prec);
    prt->papFldDes[waitRecordDESC]->offset = (unsigned short)((char *)&prec->desc - (char *)prec);
    prt->papFldDes[waitRecordASG]->offset = (unsigned short)((char *)&prec->asg - (char *)prec);
    prt->papFldDes[waitRecordSCAN]->offset = (unsigned short)((char *)&prec->scan - (char *)prec);
    prt->papFldDes[waitRecordPINI]->offset = (unsigned short)((char *)&prec->pini - (char *)prec);
    prt->papFldDes[waitRecordPHAS]->offset = (unsigned short)((char *)&prec->phas - (char *)prec);
    prt->papFldDes[waitRecordEVNT]->offset = (unsigned short)((char *)&prec->evnt - (char *)prec);
    prt->papFldDes[waitRecordTSE]->offset = (unsigned short)((char *)&prec->tse - (char *)prec);
    prt->papFldDes[waitRecordTSEL]->offset = (unsigned short)((char *)&prec->tsel - (char *)prec);
    prt->papFldDes[waitRecordDTYP]->offset = (unsigned short)((char *)&prec->dtyp - (char *)prec);
    prt->papFldDes[waitRecordDISV]->offset = (unsigned short)((char *)&prec->disv - (char *)prec);
    prt->papFldDes[waitRecordDISA]->offset = (unsigned short)((char *)&prec->disa - (char *)prec);
    prt->papFldDes[waitRecordSDIS]->offset = (unsigned short)((char *)&prec->sdis - (char *)prec);
    prt->papFldDes[waitRecordMLOK]->offset = (unsigned short)((char *)&prec->mlok - (char *)prec);
    prt->papFldDes[waitRecordMLIS]->offset = (unsigned short)((char *)&prec->mlis - (char *)prec);
    prt->papFldDes[waitRecordDISP]->offset = (unsigned short)((char *)&prec->disp - (char *)prec);
    prt->papFldDes[waitRecordPROC]->offset = (unsigned short)((char *)&prec->proc - (char *)prec);
    prt->papFldDes[waitRecordSTAT]->offset = (unsigned short)((char *)&prec->stat - (char *)prec);
    prt->papFldDes[waitRecordSEVR]->offset = (unsigned short)((char *)&prec->sevr - (char *)prec);
    prt->papFldDes[waitRecordNSTA]->offset = (unsigned short)((char *)&prec->nsta - (char *)prec);
    prt->papFldDes[waitRecordNSEV]->offset = (unsigned short)((char *)&prec->nsev - (char *)prec);
    prt->papFldDes[waitRecordACKS]->offset = (unsigned short)((char *)&prec->acks - (char *)prec);
    prt->papFldDes[waitRecordACKT]->offset = (unsigned short)((char *)&prec->ackt - (char *)prec);
    prt->papFldDes[waitRecordDISS]->offset = (unsigned short)((char *)&prec->diss - (char *)prec);
    prt->papFldDes[waitRecordLCNT]->offset = (unsigned short)((char *)&prec->lcnt - (char *)prec);
    prt->papFldDes[waitRecordPACT]->offset = (unsigned short)((char *)&prec->pact - (char *)prec);
    prt->papFldDes[waitRecordPUTF]->offset = (unsigned short)((char *)&prec->putf - (char *)prec);
    prt->papFldDes[waitRecordRPRO]->offset = (unsigned short)((char *)&prec->rpro - (char *)prec);
    prt->papFldDes[waitRecordASP]->offset = (unsigned short)((char *)&prec->asp - (char *)prec);
    prt->papFldDes[waitRecordPPN]->offset = (unsigned short)((char *)&prec->ppn - (char *)prec);
    prt->papFldDes[waitRecordPPNR]->offset = (unsigned short)((char *)&prec->ppnr - (char *)prec);
    prt->papFldDes[waitRecordSPVT]->offset = (unsigned short)((char *)&prec->spvt - (char *)prec);
    prt->papFldDes[waitRecordRSET]->offset = (unsigned short)((char *)&prec->rset - (char *)prec);
    prt->papFldDes[waitRecordDSET]->offset = (unsigned short)((char *)&prec->dset - (char *)prec);
    prt->papFldDes[waitRecordDPVT]->offset = (unsigned short)((char *)&prec->dpvt - (char *)prec);
    prt->papFldDes[waitRecordRDES]->offset = (unsigned short)((char *)&prec->rdes - (char *)prec);
    prt->papFldDes[waitRecordLSET]->offset = (unsigned short)((char *)&prec->lset - (char *)prec);
    prt->papFldDes[waitRecordPRIO]->offset = (unsigned short)((char *)&prec->prio - (char *)prec);
    prt->papFldDes[waitRecordTPRO]->offset = (unsigned short)((char *)&prec->tpro - (char *)prec);
    prt->papFldDes[waitRecordBKPT]->offset = (unsigned short)((char *)&prec->bkpt - (char *)prec);
    prt->papFldDes[waitRecordUDF]->offset = (unsigned short)((char *)&prec->udf - (char *)prec);
    prt->papFldDes[waitRecordUDFS]->offset = (unsigned short)((char *)&prec->udfs - (char *)prec);
    prt->papFldDes[waitRecordTIME]->offset = (unsigned short)((char *)&prec->time - (char *)prec);
    prt->papFldDes[waitRecordFLNK]->offset = (unsigned short)((char *)&prec->flnk - (char *)prec);
    prt->papFldDes[waitRecordVAL]->offset = (unsigned short)((char *)&prec->val - (char *)prec);
    prt->papFldDes[waitRecordPREC]->offset = (unsigned short)((char *)&prec->prec - (char *)prec);
    prt->papFldDes[waitRecordEGU]->offset = (unsigned short)((char *)&prec->egu - (char *)prec);
    prt->papFldDes[waitRecordHOPR]->offset = (unsigned short)((char *)&prec->hopr - (char *)prec);
    prt->papFldDes[waitRecordLOPR]->offset = (unsigned short)((char *)&prec->lopr - (char *)prec);
    prt->papFldDes[waitRecordDRVH]->offset = (unsigned short)((char *)&prec->drvh - (char *)prec);
    prt->papFldDes[waitRecordDRVL]->offset = (unsigned short)((char *)&prec->drvl - (char *)prec);
    prt->papFldDes[waitRecordHIHI]->offset = (unsigned short)((char *)&prec->hihi - (char *)prec);
    prt->papFldDes[waitRecordLOLO]->offset = (unsigned short)((char *)&prec->lolo - (char *)prec);
    prt->papFldDes[waitRecordHIGH]->offset = (unsigned short)((char *)&prec->high - (char *)prec);
    prt->papFldDes[waitRecordLOW]->offset = (unsigned short)((char *)&prec->low - (char *)prec);
    prt->papFldDes[waitRecordHHSV]->offset = (unsigned short)((char *)&prec->hhsv - (char *)prec);
    prt->papFldDes[waitRecordLLSV]->offset = (unsigned short)((char *)&prec->llsv - (char *)prec);
    prt->papFldDes[waitRecordHSV]->offset = (unsigned short)((char *)&prec->hsv - (char *)prec);
    prt->papFldDes[waitRecordLSV]->offset = (unsigned short)((char *)&prec->lsv - (char *)prec);
    prt->papFldDes[waitRecordHYST]->offset = (unsigned short)((char *)&prec->hyst - (char *)prec);
    prt->papFldDes[waitRecordADEL]->offset = (unsigned short)((char *)&prec->adel - (char *)prec);
    prt->papFldDes[waitRecordMDEL]->offset = (unsigned short)((char *)&prec->mdel - (char *)prec);
    prt->papFldDes[waitRecordLALM]->offset = (unsigned short)((char *)&prec->lalm - (char *)prec);
    prt->papFldDes[waitRecordALST]->offset = (unsigned short)((char *)&prec->alst - (char *)prec);
    prt->papFldDes[waitRecordMLST]->offset = (unsigned short)((char *)&prec->mlst - (char *)prec);
    prt->rec_size = sizeof(*prec);
    return 0;
}
epicsExportRegistrar(waitRecordSizeOffset);

#ifdef __cplusplus
}
#endif
#endif /* GEN_SIZE_OFFSET */

#endif /* INC_waitRecord_H */
