/* floatRecord.h generated from floatRecord.dbd */

#ifndef INC_floatRecord_H
#define INC_floatRecord_H

#include "epicsTypes.h"
#include "link.h"
#include "epicsMutex.h"
#include "ellLib.h"
#include "epicsTime.h"

typedef struct floatrRecord {
    char                name[61];   /* Record Name */
    char                desc[41];   /* Descriptor */
    char                asg[29];    /* Access Security Group */
    epicsEnum16         scan;       /* Scan Mechanism */
    epicsEnum16         pini;       /* Process at iocInit */
    epicsInt16          phas;       /* Scan Phase */
    char                evnt[40];   /* Event Name */
    epicsInt16          tse;        /* Time Stamp Event */
    DBLINK              tsel;       /* Time Stamp Link */
    epicsEnum16         dtyp;       /* Device Type */
    epicsInt16          disv;       /* Disable Value */
    epicsInt16          disa;       /* Disable */
    DBLINK              sdis;       /* Scanning Disable */
    epicsMutexId        mlok;       /* Monitor lock */
    ELLLIST             mlis;       /* Monitor List */
    epicsUInt8          disp;       /* Disable putField */
    epicsUInt8          proc;       /* Force Processing */
    epicsEnum16         stat;       /* Alarm Status */
    epicsEnum16         sevr;       /* Alarm Severity */
    epicsEnum16         nsta;       /* New Alarm Status */
    epicsEnum16         nsev;       /* New Alarm Severity */
    epicsEnum16         acks;       /* Alarm Ack Severity */
    epicsEnum16         ackt;       /* Alarm Ack Transient */
    epicsEnum16         diss;       /* Disable Alarm Sevrty */
    epicsUInt8          lcnt;       /* Lock Count */
    epicsUInt8          pact;       /* Record active */
    epicsUInt8          putf;       /* dbPutField process */
    epicsUInt8          rpro;       /* Reprocess  */
    struct asgMember    *asp;       /* Access Security Pvt */
    struct processNotify *ppn;      /* pprocessNotify */
    struct processNotifyRecord *ppnr; /* pprocessNotifyRecord */
    struct scan_element *spvt;      /* Scan Private */
    struct rset         *rset;      /* Address of RSET */
    struct dset         *dset;      /* DSET address */
    void                *dpvt;      /* Device Private */
    struct dbRecordType *rdes;      /* Address of dbRecordType */
    struct lockRecord   *lset;      /* Lock Set */
    epicsEnum16         prio;       /* Scheduling Priority */
    epicsUInt8          tpro;       /* Trace Processing */
    char                bkpt;       /* Break Point */
    epicsUInt8          udf;        /* Undefined */
    epicsEnum16         udfs;       /* Undefined Alarm Sevrty */
    epicsTimeStamp      time;       /* Time */
    DBLINK              flnk;       /* Forward Process Link */
    epicsFloat32        val;        /* Current EGU Value */
    epicsInt16          prec;       /* Display Precision */
    char                egu[16];    /* Engineering Units */
    epicsFloat32        hopr;       /* High Operating Range */
    epicsFloat32        lopr;       /* Low Operating Range */
    epicsFloat32        hihi;       /* Hihi Alarm Limit */
    epicsFloat32        lolo;       /* Lolo Alarm Limit */
    epicsFloat32        high;       /* High Alarm Limit */
    epicsFloat32        low;        /* Low Alarm Limit */
    epicsEnum16         hhsv;       /* Hihi Severity */
    epicsEnum16         llsv;       /* Lolo Severity */
    epicsEnum16         hsv;        /* High Severity */
    epicsEnum16         lsv;        /* Low Severity */
    epicsFloat32        hyst;       /* Alarm Deadband */
    epicsFloat32        adel;       /* Archive Deadband */
    epicsFloat32        mdel;       /* Monitor Deadband */
    epicsFloat32        lalm;       /* Last Value Alarmed */
    epicsFloat32        alst;       /* Last Value Archived */
    epicsFloat32        mlst;       /* Last Val Monitored */
} floatrRecord;

typedef enum {
	floatrRecordNAME = 0,
	floatrRecordDESC = 1,
	floatrRecordASG = 2,
	floatrRecordSCAN = 3,
	floatrRecordPINI = 4,
	floatrRecordPHAS = 5,
	floatrRecordEVNT = 6,
	floatrRecordTSE = 7,
	floatrRecordTSEL = 8,
	floatrRecordDTYP = 9,
	floatrRecordDISV = 10,
	floatrRecordDISA = 11,
	floatrRecordSDIS = 12,
	floatrRecordMLOK = 13,
	floatrRecordMLIS = 14,
	floatrRecordDISP = 15,
	floatrRecordPROC = 16,
	floatrRecordSTAT = 17,
	floatrRecordSEVR = 18,
	floatrRecordNSTA = 19,
	floatrRecordNSEV = 20,
	floatrRecordACKS = 21,
	floatrRecordACKT = 22,
	floatrRecordDISS = 23,
	floatrRecordLCNT = 24,
	floatrRecordPACT = 25,
	floatrRecordPUTF = 26,
	floatrRecordRPRO = 27,
	floatrRecordASP = 28,
	floatrRecordPPN = 29,
	floatrRecordPPNR = 30,
	floatrRecordSPVT = 31,
	floatrRecordRSET = 32,
	floatrRecordDSET = 33,
	floatrRecordDPVT = 34,
	floatrRecordRDES = 35,
	floatrRecordLSET = 36,
	floatrRecordPRIO = 37,
	floatrRecordTPRO = 38,
	floatrRecordBKPT = 39,
	floatrRecordUDF = 40,
	floatrRecordUDFS = 41,
	floatrRecordTIME = 42,
	floatrRecordFLNK = 43,
	floatrRecordVAL = 44,
	floatrRecordPREC = 45,
	floatrRecordEGU = 46,
	floatrRecordHOPR = 47,
	floatrRecordLOPR = 48,
	floatrRecordHIHI = 49,
	floatrRecordLOLO = 50,
	floatrRecordHIGH = 51,
	floatrRecordLOW = 52,
	floatrRecordHHSV = 53,
	floatrRecordLLSV = 54,
	floatrRecordHSV = 55,
	floatrRecordLSV = 56,
	floatrRecordHYST = 57,
	floatrRecordADEL = 58,
	floatrRecordMDEL = 59,
	floatrRecordLALM = 60,
	floatrRecordALST = 61,
	floatrRecordMLST = 62
} floatrFieldIndex;

#ifdef GEN_SIZE_OFFSET

#include <epicsAssert.h>
#include <epicsExport.h>
#ifdef __cplusplus
extern "C" {
#endif
static int floatrRecordSizeOffset(dbRecordType *prt)
{
    floatrRecord *prec = 0;

    assert(prt->no_fields == 63);
    prt->papFldDes[floatrRecordNAME]->size = sizeof(prec->name);
    prt->papFldDes[floatrRecordDESC]->size = sizeof(prec->desc);
    prt->papFldDes[floatrRecordASG]->size = sizeof(prec->asg);
    prt->papFldDes[floatrRecordSCAN]->size = sizeof(prec->scan);
    prt->papFldDes[floatrRecordPINI]->size = sizeof(prec->pini);
    prt->papFldDes[floatrRecordPHAS]->size = sizeof(prec->phas);
    prt->papFldDes[floatrRecordEVNT]->size = sizeof(prec->evnt);
    prt->papFldDes[floatrRecordTSE]->size = sizeof(prec->tse);
    prt->papFldDes[floatrRecordTSEL]->size = sizeof(prec->tsel);
    prt->papFldDes[floatrRecordDTYP]->size = sizeof(prec->dtyp);
    prt->papFldDes[floatrRecordDISV]->size = sizeof(prec->disv);
    prt->papFldDes[floatrRecordDISA]->size = sizeof(prec->disa);
    prt->papFldDes[floatrRecordSDIS]->size = sizeof(prec->sdis);
    prt->papFldDes[floatrRecordMLOK]->size = sizeof(prec->mlok);
    prt->papFldDes[floatrRecordMLIS]->size = sizeof(prec->mlis);
    prt->papFldDes[floatrRecordDISP]->size = sizeof(prec->disp);
    prt->papFldDes[floatrRecordPROC]->size = sizeof(prec->proc);
    prt->papFldDes[floatrRecordSTAT]->size = sizeof(prec->stat);
    prt->papFldDes[floatrRecordSEVR]->size = sizeof(prec->sevr);
    prt->papFldDes[floatrRecordNSTA]->size = sizeof(prec->nsta);
    prt->papFldDes[floatrRecordNSEV]->size = sizeof(prec->nsev);
    prt->papFldDes[floatrRecordACKS]->size = sizeof(prec->acks);
    prt->papFldDes[floatrRecordACKT]->size = sizeof(prec->ackt);
    prt->papFldDes[floatrRecordDISS]->size = sizeof(prec->diss);
    prt->papFldDes[floatrRecordLCNT]->size = sizeof(prec->lcnt);
    prt->papFldDes[floatrRecordPACT]->size = sizeof(prec->pact);
    prt->papFldDes[floatrRecordPUTF]->size = sizeof(prec->putf);
    prt->papFldDes[floatrRecordRPRO]->size = sizeof(prec->rpro);
    prt->papFldDes[floatrRecordASP]->size = sizeof(prec->asp);
    prt->papFldDes[floatrRecordPPN]->size = sizeof(prec->ppn);
    prt->papFldDes[floatrRecordPPNR]->size = sizeof(prec->ppnr);
    prt->papFldDes[floatrRecordSPVT]->size = sizeof(prec->spvt);
    prt->papFldDes[floatrRecordRSET]->size = sizeof(prec->rset);
    prt->papFldDes[floatrRecordDSET]->size = sizeof(prec->dset);
    prt->papFldDes[floatrRecordDPVT]->size = sizeof(prec->dpvt);
    prt->papFldDes[floatrRecordRDES]->size = sizeof(prec->rdes);
    prt->papFldDes[floatrRecordLSET]->size = sizeof(prec->lset);
    prt->papFldDes[floatrRecordPRIO]->size = sizeof(prec->prio);
    prt->papFldDes[floatrRecordTPRO]->size = sizeof(prec->tpro);
    prt->papFldDes[floatrRecordBKPT]->size = sizeof(prec->bkpt);
    prt->papFldDes[floatrRecordUDF]->size = sizeof(prec->udf);
    prt->papFldDes[floatrRecordUDFS]->size = sizeof(prec->udfs);
    prt->papFldDes[floatrRecordTIME]->size = sizeof(prec->time);
    prt->papFldDes[floatrRecordFLNK]->size = sizeof(prec->flnk);
    prt->papFldDes[floatrRecordVAL]->size = sizeof(prec->val);
    prt->papFldDes[floatrRecordPREC]->size = sizeof(prec->prec);
    prt->papFldDes[floatrRecordEGU]->size = sizeof(prec->egu);
    prt->papFldDes[floatrRecordHOPR]->size = sizeof(prec->hopr);
    prt->papFldDes[floatrRecordLOPR]->size = sizeof(prec->lopr);
    prt->papFldDes[floatrRecordHIHI]->size = sizeof(prec->hihi);
    prt->papFldDes[floatrRecordLOLO]->size = sizeof(prec->lolo);
    prt->papFldDes[floatrRecordHIGH]->size = sizeof(prec->high);
    prt->papFldDes[floatrRecordLOW]->size = sizeof(prec->low);
    prt->papFldDes[floatrRecordHHSV]->size = sizeof(prec->hhsv);
    prt->papFldDes[floatrRecordLLSV]->size = sizeof(prec->llsv);
    prt->papFldDes[floatrRecordHSV]->size = sizeof(prec->hsv);
    prt->papFldDes[floatrRecordLSV]->size = sizeof(prec->lsv);
    prt->papFldDes[floatrRecordHYST]->size = sizeof(prec->hyst);
    prt->papFldDes[floatrRecordADEL]->size = sizeof(prec->adel);
    prt->papFldDes[floatrRecordMDEL]->size = sizeof(prec->mdel);
    prt->papFldDes[floatrRecordLALM]->size = sizeof(prec->lalm);
    prt->papFldDes[floatrRecordALST]->size = sizeof(prec->alst);
    prt->papFldDes[floatrRecordMLST]->size = sizeof(prec->mlst);
    prt->papFldDes[floatrRecordNAME]->offset = (unsigned short)((char *)&prec->name - (char *)prec);
    prt->papFldDes[floatrRecordDESC]->offset = (unsigned short)((char *)&prec->desc - (char *)prec);
    prt->papFldDes[floatrRecordASG]->offset = (unsigned short)((char *)&prec->asg - (char *)prec);
    prt->papFldDes[floatrRecordSCAN]->offset = (unsigned short)((char *)&prec->scan - (char *)prec);
    prt->papFldDes[floatrRecordPINI]->offset = (unsigned short)((char *)&prec->pini - (char *)prec);
    prt->papFldDes[floatrRecordPHAS]->offset = (unsigned short)((char *)&prec->phas - (char *)prec);
    prt->papFldDes[floatrRecordEVNT]->offset = (unsigned short)((char *)&prec->evnt - (char *)prec);
    prt->papFldDes[floatrRecordTSE]->offset = (unsigned short)((char *)&prec->tse - (char *)prec);
    prt->papFldDes[floatrRecordTSEL]->offset = (unsigned short)((char *)&prec->tsel - (char *)prec);
    prt->papFldDes[floatrRecordDTYP]->offset = (unsigned short)((char *)&prec->dtyp - (char *)prec);
    prt->papFldDes[floatrRecordDISV]->offset = (unsigned short)((char *)&prec->disv - (char *)prec);
    prt->papFldDes[floatrRecordDISA]->offset = (unsigned short)((char *)&prec->disa - (char *)prec);
    prt->papFldDes[floatrRecordSDIS]->offset = (unsigned short)((char *)&prec->sdis - (char *)prec);
    prt->papFldDes[floatrRecordMLOK]->offset = (unsigned short)((char *)&prec->mlok - (char *)prec);
    prt->papFldDes[floatrRecordMLIS]->offset = (unsigned short)((char *)&prec->mlis - (char *)prec);
    prt->papFldDes[floatrRecordDISP]->offset = (unsigned short)((char *)&prec->disp - (char *)prec);
    prt->papFldDes[floatrRecordPROC]->offset = (unsigned short)((char *)&prec->proc - (char *)prec);
    prt->papFldDes[floatrRecordSTAT]->offset = (unsigned short)((char *)&prec->stat - (char *)prec);
    prt->papFldDes[floatrRecordSEVR]->offset = (unsigned short)((char *)&prec->sevr - (char *)prec);
    prt->papFldDes[floatrRecordNSTA]->offset = (unsigned short)((char *)&prec->nsta - (char *)prec);
    prt->papFldDes[floatrRecordNSEV]->offset = (unsigned short)((char *)&prec->nsev - (char *)prec);
    prt->papFldDes[floatrRecordACKS]->offset = (unsigned short)((char *)&prec->acks - (char *)prec);
    prt->papFldDes[floatrRecordACKT]->offset = (unsigned short)((char *)&prec->ackt - (char *)prec);
    prt->papFldDes[floatrRecordDISS]->offset = (unsigned short)((char *)&prec->diss - (char *)prec);
    prt->papFldDes[floatrRecordLCNT]->offset = (unsigned short)((char *)&prec->lcnt - (char *)prec);
    prt->papFldDes[floatrRecordPACT]->offset = (unsigned short)((char *)&prec->pact - (char *)prec);
    prt->papFldDes[floatrRecordPUTF]->offset = (unsigned short)((char *)&prec->putf - (char *)prec);
    prt->papFldDes[floatrRecordRPRO]->offset = (unsigned short)((char *)&prec->rpro - (char *)prec);
    prt->papFldDes[floatrRecordASP]->offset = (unsigned short)((char *)&prec->asp - (char *)prec);
    prt->papFldDes[floatrRecordPPN]->offset = (unsigned short)((char *)&prec->ppn - (char *)prec);
    prt->papFldDes[floatrRecordPPNR]->offset = (unsigned short)((char *)&prec->ppnr - (char *)prec);
    prt->papFldDes[floatrRecordSPVT]->offset = (unsigned short)((char *)&prec->spvt - (char *)prec);
    prt->papFldDes[floatrRecordRSET]->offset = (unsigned short)((char *)&prec->rset - (char *)prec);
    prt->papFldDes[floatrRecordDSET]->offset = (unsigned short)((char *)&prec->dset - (char *)prec);
    prt->papFldDes[floatrRecordDPVT]->offset = (unsigned short)((char *)&prec->dpvt - (char *)prec);
    prt->papFldDes[floatrRecordRDES]->offset = (unsigned short)((char *)&prec->rdes - (char *)prec);
    prt->papFldDes[floatrRecordLSET]->offset = (unsigned short)((char *)&prec->lset - (char *)prec);
    prt->papFldDes[floatrRecordPRIO]->offset = (unsigned short)((char *)&prec->prio - (char *)prec);
    prt->papFldDes[floatrRecordTPRO]->offset = (unsigned short)((char *)&prec->tpro - (char *)prec);
    prt->papFldDes[floatrRecordBKPT]->offset = (unsigned short)((char *)&prec->bkpt - (char *)prec);
    prt->papFldDes[floatrRecordUDF]->offset = (unsigned short)((char *)&prec->udf - (char *)prec);
    prt->papFldDes[floatrRecordUDFS]->offset = (unsigned short)((char *)&prec->udfs - (char *)prec);
    prt->papFldDes[floatrRecordTIME]->offset = (unsigned short)((char *)&prec->time - (char *)prec);
    prt->papFldDes[floatrRecordFLNK]->offset = (unsigned short)((char *)&prec->flnk - (char *)prec);
    prt->papFldDes[floatrRecordVAL]->offset = (unsigned short)((char *)&prec->val - (char *)prec);
    prt->papFldDes[floatrRecordPREC]->offset = (unsigned short)((char *)&prec->prec - (char *)prec);
    prt->papFldDes[floatrRecordEGU]->offset = (unsigned short)((char *)&prec->egu - (char *)prec);
    prt->papFldDes[floatrRecordHOPR]->offset = (unsigned short)((char *)&prec->hopr - (char *)prec);
    prt->papFldDes[floatrRecordLOPR]->offset = (unsigned short)((char *)&prec->lopr - (char *)prec);
    prt->papFldDes[floatrRecordHIHI]->offset = (unsigned short)((char *)&prec->hihi - (char *)prec);
    prt->papFldDes[floatrRecordLOLO]->offset = (unsigned short)((char *)&prec->lolo - (char *)prec);
    prt->papFldDes[floatrRecordHIGH]->offset = (unsigned short)((char *)&prec->high - (char *)prec);
    prt->papFldDes[floatrRecordLOW]->offset = (unsigned short)((char *)&prec->low - (char *)prec);
    prt->papFldDes[floatrRecordHHSV]->offset = (unsigned short)((char *)&prec->hhsv - (char *)prec);
    prt->papFldDes[floatrRecordLLSV]->offset = (unsigned short)((char *)&prec->llsv - (char *)prec);
    prt->papFldDes[floatrRecordHSV]->offset = (unsigned short)((char *)&prec->hsv - (char *)prec);
    prt->papFldDes[floatrRecordLSV]->offset = (unsigned short)((char *)&prec->lsv - (char *)prec);
    prt->papFldDes[floatrRecordHYST]->offset = (unsigned short)((char *)&prec->hyst - (char *)prec);
    prt->papFldDes[floatrRecordADEL]->offset = (unsigned short)((char *)&prec->adel - (char *)prec);
    prt->papFldDes[floatrRecordMDEL]->offset = (unsigned short)((char *)&prec->mdel - (char *)prec);
    prt->papFldDes[floatrRecordLALM]->offset = (unsigned short)((char *)&prec->lalm - (char *)prec);
    prt->papFldDes[floatrRecordALST]->offset = (unsigned short)((char *)&prec->alst - (char *)prec);
    prt->papFldDes[floatrRecordMLST]->offset = (unsigned short)((char *)&prec->mlst - (char *)prec);
    prt->rec_size = sizeof(*prec);
    return 0;
}
epicsExportRegistrar(floatrRecordSizeOffset);

#ifdef __cplusplus
}
#endif
#endif /* GEN_SIZE_OFFSET */

#endif /* INC_floatRecord_H */
