/* shortRecord.h generated from shortRecord.dbd */

#ifndef INC_shortRecord_H
#define INC_shortRecord_H

#include "epicsTypes.h"
#include "link.h"
#include "epicsMutex.h"
#include "ellLib.h"
#include "epicsTime.h"

typedef struct shortrRecord {
    char                name[61];   /* Record Name */
    char                desc[41];   /* Descriptor */
    char                asg[29];    /* Access Security Group */
    epicsEnum16         scan;       /* Scan Mechanism */
    epicsEnum16         pini;       /* Process at iocInit */
    epicsInt16          phas;       /* Scan Phase */
    char                evnt[40];   /* Event Name */
    epicsInt16          tse;        /* Time Stamp Event */
    DBLINK              tsel;       /* Time Stamp Link */
    epicsEnum16         dtyp;       /* Device Type */
    epicsInt16          disv;       /* Disable Value */
    epicsInt16          disa;       /* Disable */
    DBLINK              sdis;       /* Scanning Disable */
    epicsMutexId        mlok;       /* Monitor lock */
    ELLLIST             mlis;       /* Monitor List */
    epicsUInt8          disp;       /* Disable putField */
    epicsUInt8          proc;       /* Force Processing */
    epicsEnum16         stat;       /* Alarm Status */
    epicsEnum16         sevr;       /* Alarm Severity */
    epicsEnum16         nsta;       /* New Alarm Status */
    epicsEnum16         nsev;       /* New Alarm Severity */
    epicsEnum16         acks;       /* Alarm Ack Severity */
    epicsEnum16         ackt;       /* Alarm Ack Transient */
    epicsEnum16         diss;       /* Disable Alarm Sevrty */
    epicsUInt8          lcnt;       /* Lock Count */
    epicsUInt8          pact;       /* Record active */
    epicsUInt8          putf;       /* dbPutField process */
    epicsUInt8          rpro;       /* Reprocess  */
    struct asgMember    *asp;       /* Access Security Pvt */
    struct processNotify *ppn;      /* pprocessNotify */
    struct processNotifyRecord *ppnr; /* pprocessNotifyRecord */
    struct scan_element *spvt;      /* Scan Private */
    struct rset         *rset;      /* Address of RSET */
    struct dset         *dset;      /* DSET address */
    void                *dpvt;      /* Device Private */
    struct dbRecordType *rdes;      /* Address of dbRecordType */
    struct lockRecord   *lset;      /* Lock Set */
    epicsEnum16         prio;       /* Scheduling Priority */
    epicsUInt8          tpro;       /* Trace Processing */
    char                bkpt;       /* Break Point */
    epicsUInt8          udf;        /* Undefined */
    epicsEnum16         udfs;       /* Undefined Alarm Sevrty */
    epicsTimeStamp      time;       /* Time */
    DBLINK              flnk;       /* Forward Process Link */
    epicsInt16          val;        /* Current EGU Value */
    epicsInt16          prec;       /* Display Precision */
    char                egu[16];    /* Engineering Units */
    epicsInt16          hopr;       /* High Operating Range */
    epicsInt16          lopr;       /* Low Operating Range */
    epicsInt16          drvh;       /* High Operating Range */
    epicsInt16          drvl;       /* Low Operating Range */
    epicsInt16          hihi;       /* Hihi Alarm Limit */
    epicsInt16          lolo;       /* Lolo Alarm Limit */
    epicsInt16          high;       /* High Alarm Limit */
    epicsInt16          low;        /* Low Alarm Limit */
    epicsEnum16         hhsv;       /* Hihi Severity */
    epicsEnum16         llsv;       /* Lolo Severity */
    epicsEnum16         hsv;        /* High Severity */
    epicsEnum16         lsv;        /* Low Severity */
    epicsInt16          hyst;       /* Alarm Deadband */
    epicsInt16          adel;       /* Archive Deadband */
    epicsInt16          mdel;       /* Monitor Deadband */
    epicsInt16          lalm;       /* Last Value Alarmed */
    epicsInt16          alst;       /* Last Value Archived */
    epicsInt16          mlst;       /* Last Val Monitored */
} shortrRecord;

typedef enum {
	shortrRecordNAME = 0,
	shortrRecordDESC = 1,
	shortrRecordASG = 2,
	shortrRecordSCAN = 3,
	shortrRecordPINI = 4,
	shortrRecordPHAS = 5,
	shortrRecordEVNT = 6,
	shortrRecordTSE = 7,
	shortrRecordTSEL = 8,
	shortrRecordDTYP = 9,
	shortrRecordDISV = 10,
	shortrRecordDISA = 11,
	shortrRecordSDIS = 12,
	shortrRecordMLOK = 13,
	shortrRecordMLIS = 14,
	shortrRecordDISP = 15,
	shortrRecordPROC = 16,
	shortrRecordSTAT = 17,
	shortrRecordSEVR = 18,
	shortrRecordNSTA = 19,
	shortrRecordNSEV = 20,
	shortrRecordACKS = 21,
	shortrRecordACKT = 22,
	shortrRecordDISS = 23,
	shortrRecordLCNT = 24,
	shortrRecordPACT = 25,
	shortrRecordPUTF = 26,
	shortrRecordRPRO = 27,
	shortrRecordASP = 28,
	shortrRecordPPN = 29,
	shortrRecordPPNR = 30,
	shortrRecordSPVT = 31,
	shortrRecordRSET = 32,
	shortrRecordDSET = 33,
	shortrRecordDPVT = 34,
	shortrRecordRDES = 35,
	shortrRecordLSET = 36,
	shortrRecordPRIO = 37,
	shortrRecordTPRO = 38,
	shortrRecordBKPT = 39,
	shortrRecordUDF = 40,
	shortrRecordUDFS = 41,
	shortrRecordTIME = 42,
	shortrRecordFLNK = 43,
	shortrRecordVAL = 44,
	shortrRecordPREC = 45,
	shortrRecordEGU = 46,
	shortrRecordHOPR = 47,
	shortrRecordLOPR = 48,
	shortrRecordDRVH = 49,
	shortrRecordDRVL = 50,
	shortrRecordHIHI = 51,
	shortrRecordLOLO = 52,
	shortrRecordHIGH = 53,
	shortrRecordLOW = 54,
	shortrRecordHHSV = 55,
	shortrRecordLLSV = 56,
	shortrRecordHSV = 57,
	shortrRecordLSV = 58,
	shortrRecordHYST = 59,
	shortrRecordADEL = 60,
	shortrRecordMDEL = 61,
	shortrRecordLALM = 62,
	shortrRecordALST = 63,
	shortrRecordMLST = 64
} shortrFieldIndex;

#ifdef GEN_SIZE_OFFSET

#include <epicsAssert.h>
#include <epicsExport.h>
#ifdef __cplusplus
extern "C" {
#endif
static int shortrRecordSizeOffset(dbRecordType *prt)
{
    shortrRecord *prec = 0;

    assert(prt->no_fields == 65);
    prt->papFldDes[shortrRecordNAME]->size = sizeof(prec->name);
    prt->papFldDes[shortrRecordDESC]->size = sizeof(prec->desc);
    prt->papFldDes[shortrRecordASG]->size = sizeof(prec->asg);
    prt->papFldDes[shortrRecordSCAN]->size = sizeof(prec->scan);
    prt->papFldDes[shortrRecordPINI]->size = sizeof(prec->pini);
    prt->papFldDes[shortrRecordPHAS]->size = sizeof(prec->phas);
    prt->papFldDes[shortrRecordEVNT]->size = sizeof(prec->evnt);
    prt->papFldDes[shortrRecordTSE]->size = sizeof(prec->tse);
    prt->papFldDes[shortrRecordTSEL]->size = sizeof(prec->tsel);
    prt->papFldDes[shortrRecordDTYP]->size = sizeof(prec->dtyp);
    prt->papFldDes[shortrRecordDISV]->size = sizeof(prec->disv);
    prt->papFldDes[shortrRecordDISA]->size = sizeof(prec->disa);
    prt->papFldDes[shortrRecordSDIS]->size = sizeof(prec->sdis);
    prt->papFldDes[shortrRecordMLOK]->size = sizeof(prec->mlok);
    prt->papFldDes[shortrRecordMLIS]->size = sizeof(prec->mlis);
    prt->papFldDes[shortrRecordDISP]->size = sizeof(prec->disp);
    prt->papFldDes[shortrRecordPROC]->size = sizeof(prec->proc);
    prt->papFldDes[shortrRecordSTAT]->size = sizeof(prec->stat);
    prt->papFldDes[shortrRecordSEVR]->size = sizeof(prec->sevr);
    prt->papFldDes[shortrRecordNSTA]->size = sizeof(prec->nsta);
    prt->papFldDes[shortrRecordNSEV]->size = sizeof(prec->nsev);
    prt->papFldDes[shortrRecordACKS]->size = sizeof(prec->acks);
    prt->papFldDes[shortrRecordACKT]->size = sizeof(prec->ackt);
    prt->papFldDes[shortrRecordDISS]->size = sizeof(prec->diss);
    prt->papFldDes[shortrRecordLCNT]->size = sizeof(prec->lcnt);
    prt->papFldDes[shortrRecordPACT]->size = sizeof(prec->pact);
    prt->papFldDes[shortrRecordPUTF]->size = sizeof(prec->putf);
    prt->papFldDes[shortrRecordRPRO]->size = sizeof(prec->rpro);
    prt->papFldDes[shortrRecordASP]->size = sizeof(prec->asp);
    prt->papFldDes[shortrRecordPPN]->size = sizeof(prec->ppn);
    prt->papFldDes[shortrRecordPPNR]->size = sizeof(prec->ppnr);
    prt->papFldDes[shortrRecordSPVT]->size = sizeof(prec->spvt);
    prt->papFldDes[shortrRecordRSET]->size = sizeof(prec->rset);
    prt->papFldDes[shortrRecordDSET]->size = sizeof(prec->dset);
    prt->papFldDes[shortrRecordDPVT]->size = sizeof(prec->dpvt);
    prt->papFldDes[shortrRecordRDES]->size = sizeof(prec->rdes);
    prt->papFldDes[shortrRecordLSET]->size = sizeof(prec->lset);
    prt->papFldDes[shortrRecordPRIO]->size = sizeof(prec->prio);
    prt->papFldDes[shortrRecordTPRO]->size = sizeof(prec->tpro);
    prt->papFldDes[shortrRecordBKPT]->size = sizeof(prec->bkpt);
    prt->papFldDes[shortrRecordUDF]->size = sizeof(prec->udf);
    prt->papFldDes[shortrRecordUDFS]->size = sizeof(prec->udfs);
    prt->papFldDes[shortrRecordTIME]->size = sizeof(prec->time);
    prt->papFldDes[shortrRecordFLNK]->size = sizeof(prec->flnk);
    prt->papFldDes[shortrRecordVAL]->size = sizeof(prec->val);
    prt->papFldDes[shortrRecordPREC]->size = sizeof(prec->prec);
    prt->papFldDes[shortrRecordEGU]->size = sizeof(prec->egu);
    prt->papFldDes[shortrRecordHOPR]->size = sizeof(prec->hopr);
    prt->papFldDes[shortrRecordLOPR]->size = sizeof(prec->lopr);
    prt->papFldDes[shortrRecordDRVH]->size = sizeof(prec->drvh);
    prt->papFldDes[shortrRecordDRVL]->size = sizeof(prec->drvl);
    prt->papFldDes[shortrRecordHIHI]->size = sizeof(prec->hihi);
    prt->papFldDes[shortrRecordLOLO]->size = sizeof(prec->lolo);
    prt->papFldDes[shortrRecordHIGH]->size = sizeof(prec->high);
    prt->papFldDes[shortrRecordLOW]->size = sizeof(prec->low);
    prt->papFldDes[shortrRecordHHSV]->size = sizeof(prec->hhsv);
    prt->papFldDes[shortrRecordLLSV]->size = sizeof(prec->llsv);
    prt->papFldDes[shortrRecordHSV]->size = sizeof(prec->hsv);
    prt->papFldDes[shortrRecordLSV]->size = sizeof(prec->lsv);
    prt->papFldDes[shortrRecordHYST]->size = sizeof(prec->hyst);
    prt->papFldDes[shortrRecordADEL]->size = sizeof(prec->adel);
    prt->papFldDes[shortrRecordMDEL]->size = sizeof(prec->mdel);
    prt->papFldDes[shortrRecordLALM]->size = sizeof(prec->lalm);
    prt->papFldDes[shortrRecordALST]->size = sizeof(prec->alst);
    prt->papFldDes[shortrRecordMLST]->size = sizeof(prec->mlst);
    prt->papFldDes[shortrRecordNAME]->offset = (unsigned short)((char *)&prec->name - (char *)prec);
    prt->papFldDes[shortrRecordDESC]->offset = (unsigned short)((char *)&prec->desc - (char *)prec);
    prt->papFldDes[shortrRecordASG]->offset = (unsigned short)((char *)&prec->asg - (char *)prec);
    prt->papFldDes[shortrRecordSCAN]->offset = (unsigned short)((char *)&prec->scan - (char *)prec);
    prt->papFldDes[shortrRecordPINI]->offset = (unsigned short)((char *)&prec->pini - (char *)prec);
    prt->papFldDes[shortrRecordPHAS]->offset = (unsigned short)((char *)&prec->phas - (char *)prec);
    prt->papFldDes[shortrRecordEVNT]->offset = (unsigned short)((char *)&prec->evnt - (char *)prec);
    prt->papFldDes[shortrRecordTSE]->offset = (unsigned short)((char *)&prec->tse - (char *)prec);
    prt->papFldDes[shortrRecordTSEL]->offset = (unsigned short)((char *)&prec->tsel - (char *)prec);
    prt->papFldDes[shortrRecordDTYP]->offset = (unsigned short)((char *)&prec->dtyp - (char *)prec);
    prt->papFldDes[shortrRecordDISV]->offset = (unsigned short)((char *)&prec->disv - (char *)prec);
    prt->papFldDes[shortrRecordDISA]->offset = (unsigned short)((char *)&prec->disa - (char *)prec);
    prt->papFldDes[shortrRecordSDIS]->offset = (unsigned short)((char *)&prec->sdis - (char *)prec);
    prt->papFldDes[shortrRecordMLOK]->offset = (unsigned short)((char *)&prec->mlok - (char *)prec);
    prt->papFldDes[shortrRecordMLIS]->offset = (unsigned short)((char *)&prec->mlis - (char *)prec);
    prt->papFldDes[shortrRecordDISP]->offset = (unsigned short)((char *)&prec->disp - (char *)prec);
    prt->papFldDes[shortrRecordPROC]->offset = (unsigned short)((char *)&prec->proc - (char *)prec);
    prt->papFldDes[shortrRecordSTAT]->offset = (unsigned short)((char *)&prec->stat - (char *)prec);
    prt->papFldDes[shortrRecordSEVR]->offset = (unsigned short)((char *)&prec->sevr - (char *)prec);
    prt->papFldDes[shortrRecordNSTA]->offset = (unsigned short)((char *)&prec->nsta - (char *)prec);
    prt->papFldDes[shortrRecordNSEV]->offset = (unsigned short)((char *)&prec->nsev - (char *)prec);
    prt->papFldDes[shortrRecordACKS]->offset = (unsigned short)((char *)&prec->acks - (char *)prec);
    prt->papFldDes[shortrRecordACKT]->offset = (unsigned short)((char *)&prec->ackt - (char *)prec);
    prt->papFldDes[shortrRecordDISS]->offset = (unsigned short)((char *)&prec->diss - (char *)prec);
    prt->papFldDes[shortrRecordLCNT]->offset = (unsigned short)((char *)&prec->lcnt - (char *)prec);
    prt->papFldDes[shortrRecordPACT]->offset = (unsigned short)((char *)&prec->pact - (char *)prec);
    prt->papFldDes[shortrRecordPUTF]->offset = (unsigned short)((char *)&prec->putf - (char *)prec);
    prt->papFldDes[shortrRecordRPRO]->offset = (unsigned short)((char *)&prec->rpro - (char *)prec);
    prt->papFldDes[shortrRecordASP]->offset = (unsigned short)((char *)&prec->asp - (char *)prec);
    prt->papFldDes[shortrRecordPPN]->offset = (unsigned short)((char *)&prec->ppn - (char *)prec);
    prt->papFldDes[shortrRecordPPNR]->offset = (unsigned short)((char *)&prec->ppnr - (char *)prec);
    prt->papFldDes[shortrRecordSPVT]->offset = (unsigned short)((char *)&prec->spvt - (char *)prec);
    prt->papFldDes[shortrRecordRSET]->offset = (unsigned short)((char *)&prec->rset - (char *)prec);
    prt->papFldDes[shortrRecordDSET]->offset = (unsigned short)((char *)&prec->dset - (char *)prec);
    prt->papFldDes[shortrRecordDPVT]->offset = (unsigned short)((char *)&prec->dpvt - (char *)prec);
    prt->papFldDes[shortrRecordRDES]->offset = (unsigned short)((char *)&prec->rdes - (char *)prec);
    prt->papFldDes[shortrRecordLSET]->offset = (unsigned short)((char *)&prec->lset - (char *)prec);
    prt->papFldDes[shortrRecordPRIO]->offset = (unsigned short)((char *)&prec->prio - (char *)prec);
    prt->papFldDes[shortrRecordTPRO]->offset = (unsigned short)((char *)&prec->tpro - (char *)prec);
    prt->papFldDes[shortrRecordBKPT]->offset = (unsigned short)((char *)&prec->bkpt - (char *)prec);
    prt->papFldDes[shortrRecordUDF]->offset = (unsigned short)((char *)&prec->udf - (char *)prec);
    prt->papFldDes[shortrRecordUDFS]->offset = (unsigned short)((char *)&prec->udfs - (char *)prec);
    prt->papFldDes[shortrRecordTIME]->offset = (unsigned short)((char *)&prec->time - (char *)prec);
    prt->papFldDes[shortrRecordFLNK]->offset = (unsigned short)((char *)&prec->flnk - (char *)prec);
    prt->papFldDes[shortrRecordVAL]->offset = (unsigned short)((char *)&prec->val - (char *)prec);
    prt->papFldDes[shortrRecordPREC]->offset = (unsigned short)((char *)&prec->prec - (char *)prec);
    prt->papFldDes[shortrRecordEGU]->offset = (unsigned short)((char *)&prec->egu - (char *)prec);
    prt->papFldDes[shortrRecordHOPR]->offset = (unsigned short)((char *)&prec->hopr - (char *)prec);
    prt->papFldDes[shortrRecordLOPR]->offset = (unsigned short)((char *)&prec->lopr - (char *)prec);
    prt->papFldDes[shortrRecordDRVH]->offset = (unsigned short)((char *)&prec->drvh - (char *)prec);
    prt->papFldDes[shortrRecordDRVL]->offset = (unsigned short)((char *)&prec->drvl - (char *)prec);
    prt->papFldDes[shortrRecordHIHI]->offset = (unsigned short)((char *)&prec->hihi - (char *)prec);
    prt->papFldDes[shortrRecordLOLO]->offset = (unsigned short)((char *)&prec->lolo - (char *)prec);
    prt->papFldDes[shortrRecordHIGH]->offset = (unsigned short)((char *)&prec->high - (char *)prec);
    prt->papFldDes[shortrRecordLOW]->offset = (unsigned short)((char *)&prec->low - (char *)prec);
    prt->papFldDes[shortrRecordHHSV]->offset = (unsigned short)((char *)&prec->hhsv - (char *)prec);
    prt->papFldDes[shortrRecordLLSV]->offset = (unsigned short)((char *)&prec->llsv - (char *)prec);
    prt->papFldDes[shortrRecordHSV]->offset = (unsigned short)((char *)&prec->hsv - (char *)prec);
    prt->papFldDes[shortrRecordLSV]->offset = (unsigned short)((char *)&prec->lsv - (char *)prec);
    prt->papFldDes[shortrRecordHYST]->offset = (unsigned short)((char *)&prec->hyst - (char *)prec);
    prt->papFldDes[shortrRecordADEL]->offset = (unsigned short)((char *)&prec->adel - (char *)prec);
    prt->papFldDes[shortrRecordMDEL]->offset = (unsigned short)((char *)&prec->mdel - (char *)prec);
    prt->papFldDes[shortrRecordLALM]->offset = (unsigned short)((char *)&prec->lalm - (char *)prec);
    prt->papFldDes[shortrRecordALST]->offset = (unsigned short)((char *)&prec->alst - (char *)prec);
    prt->papFldDes[shortrRecordMLST]->offset = (unsigned short)((char *)&prec->mlst - (char *)prec);
    prt->rec_size = sizeof(*prec);
    return 0;
}
epicsExportRegistrar(shortrRecordSizeOffset);

#ifdef __cplusplus
}
#endif
#endif /* GEN_SIZE_OFFSET */

#endif /* INC_shortRecord_H */
