/* ushortRecord.h generated from ushortRecord.dbd */

#ifndef INC_ushortRecord_H
#define INC_ushortRecord_H

#include "epicsTypes.h"
#include "link.h"
#include "epicsMutex.h"
#include "ellLib.h"
#include "epicsTime.h"

typedef struct ushortRecord {
    char                name[61];   /* Record Name */
    char                desc[41];   /* Descriptor */
    char                asg[29];    /* Access Security Group */
    epicsEnum16         scan;       /* Scan Mechanism */
    epicsEnum16         pini;       /* Process at iocInit */
    epicsInt16          phas;       /* Scan Phase */
    char                evnt[40];   /* Event Name */
    epicsInt16          tse;        /* Time Stamp Event */
    DBLINK              tsel;       /* Time Stamp Link */
    epicsEnum16         dtyp;       /* Device Type */
    epicsInt16          disv;       /* Disable Value */
    epicsInt16          disa;       /* Disable */
    DBLINK              sdis;       /* Scanning Disable */
    epicsMutexId        mlok;       /* Monitor lock */
    ELLLIST             mlis;       /* Monitor List */
    epicsUInt8          disp;       /* Disable putField */
    epicsUInt8          proc;       /* Force Processing */
    epicsEnum16         stat;       /* Alarm Status */
    epicsEnum16         sevr;       /* Alarm Severity */
    epicsEnum16         nsta;       /* New Alarm Status */
    epicsEnum16         nsev;       /* New Alarm Severity */
    epicsEnum16         acks;       /* Alarm Ack Severity */
    epicsEnum16         ackt;       /* Alarm Ack Transient */
    epicsEnum16         diss;       /* Disable Alarm Sevrty */
    epicsUInt8          lcnt;       /* Lock Count */
    epicsUInt8          pact;       /* Record active */
    epicsUInt8          putf;       /* dbPutField process */
    epicsUInt8          rpro;       /* Reprocess  */
    struct asgMember    *asp;       /* Access Security Pvt */
    struct processNotify *ppn;      /* pprocessNotify */
    struct processNotifyRecord *ppnr; /* pprocessNotifyRecord */
    struct scan_element *spvt;      /* Scan Private */
    struct rset         *rset;      /* Address of RSET */
    struct dset         *dset;      /* DSET address */
    void                *dpvt;      /* Device Private */
    struct dbRecordType *rdes;      /* Address of dbRecordType */
    struct lockRecord   *lset;      /* Lock Set */
    epicsEnum16         prio;       /* Scheduling Priority */
    epicsUInt8          tpro;       /* Trace Processing */
    char                bkpt;       /* Break Point */
    epicsUInt8          udf;        /* Undefined */
    epicsEnum16         udfs;       /* Undefined Alarm Sevrty */
    epicsTimeStamp      time;       /* Time */
    DBLINK              flnk;       /* Forward Process Link */
    epicsUInt16         val;        /* Current EGU Value */
    epicsUInt16         prec;       /* Display Precision */
    char                egu[16];    /* Engineering Units */
    epicsUInt16         hopr;       /* High Operating Range */
    epicsUInt16         lopr;       /* Low Operating Range */
    epicsUInt16         drvh;       /* High Operating Range */
    epicsUInt16         drvl;       /* Low Operating Range */
    epicsUInt16         hihi;       /* Hihi Alarm Limit */
    epicsUInt16         lolo;       /* Lolo Alarm Limit */
    epicsUInt16         high;       /* High Alarm Limit */
    epicsUInt16         low;        /* Low Alarm Limit */
    epicsEnum16         hhsv;       /* Hihi Severity */
    epicsEnum16         llsv;       /* Lolo Severity */
    epicsEnum16         hsv;        /* High Severity */
    epicsEnum16         lsv;        /* Low Severity */
    epicsUInt16         hyst;       /* Alarm Deadband */
    epicsUInt16         adel;       /* Archive Deadband */
    epicsUInt16         mdel;       /* Monitor Deadband */
    epicsUInt16         lalm;       /* Last Value Alarmed */
    epicsUInt16         alst;       /* Last Value Archived */
    epicsUInt16         mlst;       /* Last Val Monitored */
} ushortRecord;

typedef enum {
	ushortRecordNAME = 0,
	ushortRecordDESC = 1,
	ushortRecordASG = 2,
	ushortRecordSCAN = 3,
	ushortRecordPINI = 4,
	ushortRecordPHAS = 5,
	ushortRecordEVNT = 6,
	ushortRecordTSE = 7,
	ushortRecordTSEL = 8,
	ushortRecordDTYP = 9,
	ushortRecordDISV = 10,
	ushortRecordDISA = 11,
	ushortRecordSDIS = 12,
	ushortRecordMLOK = 13,
	ushortRecordMLIS = 14,
	ushortRecordDISP = 15,
	ushortRecordPROC = 16,
	ushortRecordSTAT = 17,
	ushortRecordSEVR = 18,
	ushortRecordNSTA = 19,
	ushortRecordNSEV = 20,
	ushortRecordACKS = 21,
	ushortRecordACKT = 22,
	ushortRecordDISS = 23,
	ushortRecordLCNT = 24,
	ushortRecordPACT = 25,
	ushortRecordPUTF = 26,
	ushortRecordRPRO = 27,
	ushortRecordASP = 28,
	ushortRecordPPN = 29,
	ushortRecordPPNR = 30,
	ushortRecordSPVT = 31,
	ushortRecordRSET = 32,
	ushortRecordDSET = 33,
	ushortRecordDPVT = 34,
	ushortRecordRDES = 35,
	ushortRecordLSET = 36,
	ushortRecordPRIO = 37,
	ushortRecordTPRO = 38,
	ushortRecordBKPT = 39,
	ushortRecordUDF = 40,
	ushortRecordUDFS = 41,
	ushortRecordTIME = 42,
	ushortRecordFLNK = 43,
	ushortRecordVAL = 44,
	ushortRecordPREC = 45,
	ushortRecordEGU = 46,
	ushortRecordHOPR = 47,
	ushortRecordLOPR = 48,
	ushortRecordDRVH = 49,
	ushortRecordDRVL = 50,
	ushortRecordHIHI = 51,
	ushortRecordLOLO = 52,
	ushortRecordHIGH = 53,
	ushortRecordLOW = 54,
	ushortRecordHHSV = 55,
	ushortRecordLLSV = 56,
	ushortRecordHSV = 57,
	ushortRecordLSV = 58,
	ushortRecordHYST = 59,
	ushortRecordADEL = 60,
	ushortRecordMDEL = 61,
	ushortRecordLALM = 62,
	ushortRecordALST = 63,
	ushortRecordMLST = 64
} ushortFieldIndex;

#ifdef GEN_SIZE_OFFSET

#include <epicsAssert.h>
#include <epicsExport.h>
#ifdef __cplusplus
extern "C" {
#endif
static int ushortRecordSizeOffset(dbRecordType *prt)
{
    ushortRecord *prec = 0;

    assert(prt->no_fields == 65);
    prt->papFldDes[ushortRecordNAME]->size = sizeof(prec->name);
    prt->papFldDes[ushortRecordDESC]->size = sizeof(prec->desc);
    prt->papFldDes[ushortRecordASG]->size = sizeof(prec->asg);
    prt->papFldDes[ushortRecordSCAN]->size = sizeof(prec->scan);
    prt->papFldDes[ushortRecordPINI]->size = sizeof(prec->pini);
    prt->papFldDes[ushortRecordPHAS]->size = sizeof(prec->phas);
    prt->papFldDes[ushortRecordEVNT]->size = sizeof(prec->evnt);
    prt->papFldDes[ushortRecordTSE]->size = sizeof(prec->tse);
    prt->papFldDes[ushortRecordTSEL]->size = sizeof(prec->tsel);
    prt->papFldDes[ushortRecordDTYP]->size = sizeof(prec->dtyp);
    prt->papFldDes[ushortRecordDISV]->size = sizeof(prec->disv);
    prt->papFldDes[ushortRecordDISA]->size = sizeof(prec->disa);
    prt->papFldDes[ushortRecordSDIS]->size = sizeof(prec->sdis);
    prt->papFldDes[ushortRecordMLOK]->size = sizeof(prec->mlok);
    prt->papFldDes[ushortRecordMLIS]->size = sizeof(prec->mlis);
    prt->papFldDes[ushortRecordDISP]->size = sizeof(prec->disp);
    prt->papFldDes[ushortRecordPROC]->size = sizeof(prec->proc);
    prt->papFldDes[ushortRecordSTAT]->size = sizeof(prec->stat);
    prt->papFldDes[ushortRecordSEVR]->size = sizeof(prec->sevr);
    prt->papFldDes[ushortRecordNSTA]->size = sizeof(prec->nsta);
    prt->papFldDes[ushortRecordNSEV]->size = sizeof(prec->nsev);
    prt->papFldDes[ushortRecordACKS]->size = sizeof(prec->acks);
    prt->papFldDes[ushortRecordACKT]->size = sizeof(prec->ackt);
    prt->papFldDes[ushortRecordDISS]->size = sizeof(prec->diss);
    prt->papFldDes[ushortRecordLCNT]->size = sizeof(prec->lcnt);
    prt->papFldDes[ushortRecordPACT]->size = sizeof(prec->pact);
    prt->papFldDes[ushortRecordPUTF]->size = sizeof(prec->putf);
    prt->papFldDes[ushortRecordRPRO]->size = sizeof(prec->rpro);
    prt->papFldDes[ushortRecordASP]->size = sizeof(prec->asp);
    prt->papFldDes[ushortRecordPPN]->size = sizeof(prec->ppn);
    prt->papFldDes[ushortRecordPPNR]->size = sizeof(prec->ppnr);
    prt->papFldDes[ushortRecordSPVT]->size = sizeof(prec->spvt);
    prt->papFldDes[ushortRecordRSET]->size = sizeof(prec->rset);
    prt->papFldDes[ushortRecordDSET]->size = sizeof(prec->dset);
    prt->papFldDes[ushortRecordDPVT]->size = sizeof(prec->dpvt);
    prt->papFldDes[ushortRecordRDES]->size = sizeof(prec->rdes);
    prt->papFldDes[ushortRecordLSET]->size = sizeof(prec->lset);
    prt->papFldDes[ushortRecordPRIO]->size = sizeof(prec->prio);
    prt->papFldDes[ushortRecordTPRO]->size = sizeof(prec->tpro);
    prt->papFldDes[ushortRecordBKPT]->size = sizeof(prec->bkpt);
    prt->papFldDes[ushortRecordUDF]->size = sizeof(prec->udf);
    prt->papFldDes[ushortRecordUDFS]->size = sizeof(prec->udfs);
    prt->papFldDes[ushortRecordTIME]->size = sizeof(prec->time);
    prt->papFldDes[ushortRecordFLNK]->size = sizeof(prec->flnk);
    prt->papFldDes[ushortRecordVAL]->size = sizeof(prec->val);
    prt->papFldDes[ushortRecordPREC]->size = sizeof(prec->prec);
    prt->papFldDes[ushortRecordEGU]->size = sizeof(prec->egu);
    prt->papFldDes[ushortRecordHOPR]->size = sizeof(prec->hopr);
    prt->papFldDes[ushortRecordLOPR]->size = sizeof(prec->lopr);
    prt->papFldDes[ushortRecordDRVH]->size = sizeof(prec->drvh);
    prt->papFldDes[ushortRecordDRVL]->size = sizeof(prec->drvl);
    prt->papFldDes[ushortRecordHIHI]->size = sizeof(prec->hihi);
    prt->papFldDes[ushortRecordLOLO]->size = sizeof(prec->lolo);
    prt->papFldDes[ushortRecordHIGH]->size = sizeof(prec->high);
    prt->papFldDes[ushortRecordLOW]->size = sizeof(prec->low);
    prt->papFldDes[ushortRecordHHSV]->size = sizeof(prec->hhsv);
    prt->papFldDes[ushortRecordLLSV]->size = sizeof(prec->llsv);
    prt->papFldDes[ushortRecordHSV]->size = sizeof(prec->hsv);
    prt->papFldDes[ushortRecordLSV]->size = sizeof(prec->lsv);
    prt->papFldDes[ushortRecordHYST]->size = sizeof(prec->hyst);
    prt->papFldDes[ushortRecordADEL]->size = sizeof(prec->adel);
    prt->papFldDes[ushortRecordMDEL]->size = sizeof(prec->mdel);
    prt->papFldDes[ushortRecordLALM]->size = sizeof(prec->lalm);
    prt->papFldDes[ushortRecordALST]->size = sizeof(prec->alst);
    prt->papFldDes[ushortRecordMLST]->size = sizeof(prec->mlst);
    prt->papFldDes[ushortRecordNAME]->offset = (unsigned short)((char *)&prec->name - (char *)prec);
    prt->papFldDes[ushortRecordDESC]->offset = (unsigned short)((char *)&prec->desc - (char *)prec);
    prt->papFldDes[ushortRecordASG]->offset = (unsigned short)((char *)&prec->asg - (char *)prec);
    prt->papFldDes[ushortRecordSCAN]->offset = (unsigned short)((char *)&prec->scan - (char *)prec);
    prt->papFldDes[ushortRecordPINI]->offset = (unsigned short)((char *)&prec->pini - (char *)prec);
    prt->papFldDes[ushortRecordPHAS]->offset = (unsigned short)((char *)&prec->phas - (char *)prec);
    prt->papFldDes[ushortRecordEVNT]->offset = (unsigned short)((char *)&prec->evnt - (char *)prec);
    prt->papFldDes[ushortRecordTSE]->offset = (unsigned short)((char *)&prec->tse - (char *)prec);
    prt->papFldDes[ushortRecordTSEL]->offset = (unsigned short)((char *)&prec->tsel - (char *)prec);
    prt->papFldDes[ushortRecordDTYP]->offset = (unsigned short)((char *)&prec->dtyp - (char *)prec);
    prt->papFldDes[ushortRecordDISV]->offset = (unsigned short)((char *)&prec->disv - (char *)prec);
    prt->papFldDes[ushortRecordDISA]->offset = (unsigned short)((char *)&prec->disa - (char *)prec);
    prt->papFldDes[ushortRecordSDIS]->offset = (unsigned short)((char *)&prec->sdis - (char *)prec);
    prt->papFldDes[ushortRecordMLOK]->offset = (unsigned short)((char *)&prec->mlok - (char *)prec);
    prt->papFldDes[ushortRecordMLIS]->offset = (unsigned short)((char *)&prec->mlis - (char *)prec);
    prt->papFldDes[ushortRecordDISP]->offset = (unsigned short)((char *)&prec->disp - (char *)prec);
    prt->papFldDes[ushortRecordPROC]->offset = (unsigned short)((char *)&prec->proc - (char *)prec);
    prt->papFldDes[ushortRecordSTAT]->offset = (unsigned short)((char *)&prec->stat - (char *)prec);
    prt->papFldDes[ushortRecordSEVR]->offset = (unsigned short)((char *)&prec->sevr - (char *)prec);
    prt->papFldDes[ushortRecordNSTA]->offset = (unsigned short)((char *)&prec->nsta - (char *)prec);
    prt->papFldDes[ushortRecordNSEV]->offset = (unsigned short)((char *)&prec->nsev - (char *)prec);
    prt->papFldDes[ushortRecordACKS]->offset = (unsigned short)((char *)&prec->acks - (char *)prec);
    prt->papFldDes[ushortRecordACKT]->offset = (unsigned short)((char *)&prec->ackt - (char *)prec);
    prt->papFldDes[ushortRecordDISS]->offset = (unsigned short)((char *)&prec->diss - (char *)prec);
    prt->papFldDes[ushortRecordLCNT]->offset = (unsigned short)((char *)&prec->lcnt - (char *)prec);
    prt->papFldDes[ushortRecordPACT]->offset = (unsigned short)((char *)&prec->pact - (char *)prec);
    prt->papFldDes[ushortRecordPUTF]->offset = (unsigned short)((char *)&prec->putf - (char *)prec);
    prt->papFldDes[ushortRecordRPRO]->offset = (unsigned short)((char *)&prec->rpro - (char *)prec);
    prt->papFldDes[ushortRecordASP]->offset = (unsigned short)((char *)&prec->asp - (char *)prec);
    prt->papFldDes[ushortRecordPPN]->offset = (unsigned short)((char *)&prec->ppn - (char *)prec);
    prt->papFldDes[ushortRecordPPNR]->offset = (unsigned short)((char *)&prec->ppnr - (char *)prec);
    prt->papFldDes[ushortRecordSPVT]->offset = (unsigned short)((char *)&prec->spvt - (char *)prec);
    prt->papFldDes[ushortRecordRSET]->offset = (unsigned short)((char *)&prec->rset - (char *)prec);
    prt->papFldDes[ushortRecordDSET]->offset = (unsigned short)((char *)&prec->dset - (char *)prec);
    prt->papFldDes[ushortRecordDPVT]->offset = (unsigned short)((char *)&prec->dpvt - (char *)prec);
    prt->papFldDes[ushortRecordRDES]->offset = (unsigned short)((char *)&prec->rdes - (char *)prec);
    prt->papFldDes[ushortRecordLSET]->offset = (unsigned short)((char *)&prec->lset - (char *)prec);
    prt->papFldDes[ushortRecordPRIO]->offset = (unsigned short)((char *)&prec->prio - (char *)prec);
    prt->papFldDes[ushortRecordTPRO]->offset = (unsigned short)((char *)&prec->tpro - (char *)prec);
    prt->papFldDes[ushortRecordBKPT]->offset = (unsigned short)((char *)&prec->bkpt - (char *)prec);
    prt->papFldDes[ushortRecordUDF]->offset = (unsigned short)((char *)&prec->udf - (char *)prec);
    prt->papFldDes[ushortRecordUDFS]->offset = (unsigned short)((char *)&prec->udfs - (char *)prec);
    prt->papFldDes[ushortRecordTIME]->offset = (unsigned short)((char *)&prec->time - (char *)prec);
    prt->papFldDes[ushortRecordFLNK]->offset = (unsigned short)((char *)&prec->flnk - (char *)prec);
    prt->papFldDes[ushortRecordVAL]->offset = (unsigned short)((char *)&prec->val - (char *)prec);
    prt->papFldDes[ushortRecordPREC]->offset = (unsigned short)((char *)&prec->prec - (char *)prec);
    prt->papFldDes[ushortRecordEGU]->offset = (unsigned short)((char *)&prec->egu - (char *)prec);
    prt->papFldDes[ushortRecordHOPR]->offset = (unsigned short)((char *)&prec->hopr - (char *)prec);
    prt->papFldDes[ushortRecordLOPR]->offset = (unsigned short)((char *)&prec->lopr - (char *)prec);
    prt->papFldDes[ushortRecordDRVH]->offset = (unsigned short)((char *)&prec->drvh - (char *)prec);
    prt->papFldDes[ushortRecordDRVL]->offset = (unsigned short)((char *)&prec->drvl - (char *)prec);
    prt->papFldDes[ushortRecordHIHI]->offset = (unsigned short)((char *)&prec->hihi - (char *)prec);
    prt->papFldDes[ushortRecordLOLO]->offset = (unsigned short)((char *)&prec->lolo - (char *)prec);
    prt->papFldDes[ushortRecordHIGH]->offset = (unsigned short)((char *)&prec->high - (char *)prec);
    prt->papFldDes[ushortRecordLOW]->offset = (unsigned short)((char *)&prec->low - (char *)prec);
    prt->papFldDes[ushortRecordHHSV]->offset = (unsigned short)((char *)&prec->hhsv - (char *)prec);
    prt->papFldDes[ushortRecordLLSV]->offset = (unsigned short)((char *)&prec->llsv - (char *)prec);
    prt->papFldDes[ushortRecordHSV]->offset = (unsigned short)((char *)&prec->hsv - (char *)prec);
    prt->papFldDes[ushortRecordLSV]->offset = (unsigned short)((char *)&prec->lsv - (char *)prec);
    prt->papFldDes[ushortRecordHYST]->offset = (unsigned short)((char *)&prec->hyst - (char *)prec);
    prt->papFldDes[ushortRecordADEL]->offset = (unsigned short)((char *)&prec->adel - (char *)prec);
    prt->papFldDes[ushortRecordMDEL]->offset = (unsigned short)((char *)&prec->mdel - (char *)prec);
    prt->papFldDes[ushortRecordLALM]->offset = (unsigned short)((char *)&prec->lalm - (char *)prec);
    prt->papFldDes[ushortRecordALST]->offset = (unsigned short)((char *)&prec->alst - (char *)prec);
    prt->papFldDes[ushortRecordMLST]->offset = (unsigned short)((char *)&prec->mlst - (char *)prec);
    prt->rec_size = sizeof(*prec);
    return 0;
}
epicsExportRegistrar(ushortRecordSizeOffset);

#ifdef __cplusplus
}
#endif
#endif /* GEN_SIZE_OFFSET */

#endif /* INC_ushortRecord_H */
